<?php 

// +------------------------------------------------------------------+
// |                                                            [KHXC]|
// | Copyright 1999-2007 Kryptronic, Inc. All rights reserved.        |
// |                                                                  |
// | All Kryptronic software is copyrighted, trademarked, developed   |
// | and licensed by Kryptronic, Inc. All Kryptronic software is      |
// | distributed under license.                                       |
// |                                                                  |
// | View the license agreement for more information.  Installation   |
// | of this software package indicates acceptance of the license     |
// | agreement.                                                       |
// |                                                                  |
// | Application Information: http://www.kryptronic.com/              |
// |                                                                  |
// | Software Name:     Kryptronic Hybrix X Core (KHXC)               |
// | Software Version:  6.6.0                                         |
// | Package Date:      January 15, 2007                              |
// | Author:            Nick Hendler, Webmaster, Kryptronic, Inc.     |
// | Author Email:      support@kryptronic.com                        |
// |                                                                  |
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | IF INSTRUCTED TO EDIT THE $main_path_force VARIABLE, EDIT THE    |
// | VALUE BETWEEN THE SINGLE QUOTES ON THE FOLLOWING LINE.           |
// +------------------------------------------------------------------+

$main_path_force   = '';

$perms_level_files  = '777';
$perms_level_dirs   = '777';
$perms_level_config = '777';

// +------------------------------------------------------------------+
// | DO NOT EDIT BELOW THIS LINE.                                     |
// +------------------------------------------------------------------+

// +--
// | The following parameters are to be left alone.  We initially set
// | this script up to handle its own errors, run using the BackEnd
// | interface and to produce output (so we can use KHXC_Error).  Right
// | before this script prints displays, we turn output off and destroy
// | the KHXC_Display output buffer.
// +--

$interface = 'BackEnd';
$output    = 1;
$errhandle = 1;

// +--
// | Enter the importer script name if it has been changed.  We also
// | set the script up as a robot so cookies are not printed.
// +--

$importer_script = 'importer-ccp51-uk.php';
$importer_name   = 'ClickCartPro 5.1 (tiki)';
$robot           = 'KHXC Data Importer: ' . $importer_name;

// +--
// | Main program loader.  This object call creates an instance
// | of the KHXCmain class.  When the exec() function runs, the
// | program runs and produces output.  We exit() afterwards.
// +--

$khxcmain = new KHXCmain;

$khxcmain->exec(array('khxc.main_path_force'    => $main_path_force,
                      'khxc.interface'          => $interface,
                      'khxc.output'             => $output,
                      'khxc.errhandle'          => $errhandle,
                      'khxc.perms_level_files'  => $perms_level_files,
                      'khxc.perms_level_dirs'   => $perms_level_dirs,
                      'khxc.perms_level_config' => $perms_level_config,
                      'importer.script_name'    => $importer_script,
                      'importer.name'           => $importer_name,
                      'khxc.robot'              => $robot));

// +--
// | Exit() is called from within the KHXC during it's shutdown
// | function, however it's good practice to call it here as well
// | to handle garbage collection.
// +--

exit();

// +------------------------------------------------------------------+
// | Class Definition                                           [KHXC]|
// +------------------------------------------------------------------+

class KHXCmain {

// +--
// | This class is used to verify the PHP environment we're running
// | in, load and execute the KHXC class and provide error handling
// | outside of the scope of the main KHXC class.
// +--

// +------------------------------------------------------------------+
// | Class Variables                                            [KHXC]|
// +------------------------------------------------------------------+

var $class   = 'KHXCmain';
var $version = '6.6.0';
var $cerror;

// +------------------------------------------------------------------+
// | Constructor Function                                       [KHXC]|
// +------------------------------------------------------------------+

function KHXCmain () {

// +--
// | This is the constructor function.  This function starts up the
// | class.  Any pre-load variable assignments go here.
// +--

// +--
// | Return object.
// +--

return $this;

} // End of function.

// +------------------------------------------------------------------+
// | Function: exec                                             [KHXC]|
// +------------------------------------------------------------------+

function exec ($input = array()) {

// +--
// | This routine is run to run the internals of the class.  Main class
// | logic is contained in this function.
// +--

// +--
// | Globalize our input array.
// +--

if (!(empty($input))) {

     foreach ($input as $key => $value) {$this->globals($key,$value);}

} // End of if statement.

// +--
// | Set error handling up to output errors to the browser.  We handle
// | all errors except for E_NOTICE errors.
// +--

ini_set('display_errors','1');

error_reporting(E_ALL ^ E_NOTICE);

set_error_handler(array(&$this,'error_display'));

// +--
// | Determine the directory from where we're running this program.
// +--

$path = $this->globals('khxc.main_path_force');

if ((!(empty($path))) && (@file_exists($path))) {

     $path = $this->globals('khxc.main_path_force');

} elseif (@file_exists(dirname(__FILE__))) {

     $path = dirname(__FILE__);

} elseif (@file_exists(getcwd())) {

     $path = getcwd();

} elseif (@file_exists(dirname($_SERVER['PATH_TRANSLATED']))) {

     $path = dirname($_SERVER['PATH_TRANSLATED']);

} elseif (@file_exists(dirname($_SERVER['SCRIPT_FILENAME']))) {

     $path = dirname($_SERVER['SCRIPT_FILENAME']);

} else {

     $errstr = "

     <p>This script could not determine the directory from which it is 
     being executed.  You need to edit the scripts 'index.php', 'admin.php' 
     and 'installer.php' and enter a value for the \$main_path_force 
     variable at the top of those scripts. Follow the instructions in each of 
     those scripts for more information.</p>

     <p>If you have already edited the \$main_path_force variable and are 
     seeing this message again, the value you used for that variable 
     appears to be incorrect.  Please try again.</p>

     ";

     trigger_error($errstr,E_USER_ERROR);

} // End of if statement.

// +--
// | Format our working directory we've just determined and globalize it.
// +--

$path = $this->paths_convert($path);

$this->globals('khxc.main_path_force',$path);

// +--
// | Include our config.php in the public directory.  Globalize the 
// | config array.
// +--

if (@file_exists($this->globals('khxc.main_path_force') . '/config.php')) {

     include($this->globals('khxc.main_path_force') . '/config.php');

     foreach ($config as $key => $value) {$this->globals($key,$value);}

     unset($config);

} // End of if statement.

// +--
// | If the $config array key 'khxc.path_private' was not defined,
// | we had a problem and need to error out.
// +--

$pathpriv = $this->globals('khxc.path_private');

if (empty($pathpriv)) {

     $errstr = "

     <p>It appears you have not run the Kyrptronic Hybrid X Core (KHXC)
     installer script.  You need to run the installer script before
     accessing this script.</p>

     <p><a href=\"installer.php\" title=\"Installer\">Click here to run
     the installer script.</a></p>

     ";

     trigger_error($errstr,E_USER_ERROR);

} // End of if statement.

// +--
// | Our private config file will be included automatically
// | by the KHXC when it loads up.
// |
// | Now that we have our public config file included,
// | we can include our main KHXC file.
// +--

$privpath = $this->globals('khxc.path_private');

if (@file_exists($privpath . '/core/KHXC/KHXC.php')) {

     include_once($privpath . '/core/KHXC/KHXC.php');

// +--
// | If there is a problem finding the file, we error out.
// +--

} else {

     $errstr = "

     <p>This script could not locate the file 'KHXC.php' in the
     directory:</p>

     <p>{$privpath}/core/KHXC</p>

     <p>This could be the result of an incomplete installation.  The
     configuration files created by the installer appear to be complete, 
     however the installation of the codebase is incomplete.  This is a
     fatal error that cannot be resolved automatically.  Reinstall the
     software to continue.</p>

     <p><a href=\"installer.php\" title=\"Installer\">Click here to run
     the installer script.</a></p>

     ";

     trigger_error($errstr,E_USER_ERROR);

} // End of if statement.

// +--
// | If we were able to include our main KHXC file, we can run the KHXC.
// | Above we set 'output' to '0' and 'errhandle' to '1' so the KHXC will 
// | produce no output and not trigger errors internally.  There is no need 
// | to check for errors at this level.  
// |
// | Create the KHXC object.
// +--

global $xglobal_cache;

$khxc =& new KHXC($xglobal_cache);

if ($khxc->IsError($khxc->cerror)) {

     trigger_error($khxc->cerror->GetMessage(),E_USER_ERROR);

} // End of if statement.

// +--
// | Run the importer.  We pass it's constructor a reference to our
// | KHXC object.
// +--

$importer =& new KHXCimporter($khxc);

if ($khxc->IsError($importer->cerror)) {

     trigger_error($importer->cerror->GetMessage(),E_USER_ERROR);

} // End of if statement.

$importer->exec();

// +--
// | Run KHXC shutdown method.
// +--

$khxc->shutdown();

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: globals                                                |
// +------------------------------------------------------------------+

function globals ($name = '',$value = null,$default = null) {

// +--
// | This function maintains a global array of global variables for
// | use within the program.  Global variables can be set, changed and
// | obtained from this function.
// +--

global $xglobal_cache;

// +--
// | If the request contained a default identifier (passed as a true
// | value), we set a default value if the global doesn't exist.
// +--

if ((!(empty($name))) && (isset($value)) && (isset($default)) && (!(isset($xglobal_cache[$name])))) {

     $xglobal_cache[$name] = $value;

     return $value;

} // End of if statement.

// +--
// | Set requests have both a name and value passed
// | to this function.
// +--

if ((!(empty($name))) && (isset($value)) && (!(isset($default)))) {

     $xglobal_cache[$name] = $value;

     return $value;

} // End of if statement.

// +--
// | Get requests have only a global variable name
// | passed to this function.
// +--

if ((!(empty($name))) && (isset($xglobal_cache[$name]))) {

     return $xglobal_cache[$name];

} // End of if statement.

// +--
// | All other requests result in a null return value.
// +--

return null;

} // End of function.

// +------------------------------------------------------------------+
// | Function: paths_convert                                          |
// +------------------------------------------------------------------+

function paths_convert ($string) {

// +--
// | This function converts filesystem paths to unix-style and strips
// | any trailing slashes.
// +--

while (preg_match('/\\\\/',$string)) {$string = preg_replace('/\\\\/','/',$string);}

while (preg_match('/\/\//',$string)) {$string = preg_replace('/\/\//','/',$string);}

$string = preg_replace('/\/$/','',$string);

return $string;

} // End of function.

// +------------------------------------------------------------------+
// | Function: paths_strip                                            |
// +------------------------------------------------------------------+

function paths_strip ($string) {

// +--
// | This function strips full server paths from a given string for
// | security purposes.
// +--

$pathpub   = $this->globals('khxc.path_public');
$pathpriv  = $this->globals('khxc.path_private');
$pathforce = $this->globals('khxc.main_path_force');

$string = str_replace('\\','/',$string);

if (!(empty($pathforce))) {

     $find   = preg_quote($pathforce . '/','/');
     $string = preg_replace('/' . $find . '/','/',$string);

} // End of if statement.
 
if (!(empty($pathpub))) {

     $find   = preg_quote($pathpub . '/','/');
     $string = preg_replace('/' . $find . '/','/',$string);

} // End of if statement.

if (!(empty($pathpriv))) {

     $find   = preg_quote($pathpriv . '/','/');
     $string = preg_replace('/' . $find . '/','/',$string);

} // End of if statement.

return $string;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_display                                          |
// +------------------------------------------------------------------+

function error_display ($errno = '',$errstr = '',$errfile = '',$errline = '') {

// +--
// | This function is called via PHP when an error is encountered.
// | Scripts pass errors through this function via PHP's trigger_error
// | function using:
// |
// | trigger_error('some_error_message',E_USER_ERROR);
// | 
// | PHP also passes errors through this function without script
// | intervention.
// +--

// +--
// | If we've hit this function with a suppressed error or an E_STRICT
// | or E_NOTICE error, we return.
// +--

if ((error_reporting() == 0) || ($errno == E_NOTICE) || ($errno == E_STRICT)) {

     return 1;

} // End of if statement.

// +--
// | Modify our $errfile if it is non-blank.  We want to remove
// | full paths from error messages to increase security.
// +--

if ($errfile) {$errfile = $this->paths_strip($errfile);}

// +--
// | Modify our $errstr if it is non-blank.  We want to add <p>
// | tags if they're not there.
// +--

if (($errstr) && (!(preg_match('/<p>/',$errstr)))) {

     $errstr = '<p>' . $errstr . '</p>';

} // End of if statement.

// +--
// | Define our date (four digit year).
// +--

$date_year = @date('Y');

// +--
// | Print output header.
// +--

print $this->error_div_header();

// +--
// | Print output content.
// +--

if ($errstr) {print $this->error_div_content($errstr);}

// +--
// | Print output info.
// +--

if ($errno && $errline && $errfile) {print $this->error_div_info($errno,$errline,$errfile);}

// +--
// | Print output footer.
// +--

print $this->error_div_footer($date_year);

// +--
// | This was a fatal error so we exit.
// +--

exit();

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_header                                       |
// +------------------------------------------------------------------+

function error_div_header () {

// +--
// | This function prints the error header.
// +--

$xhtml = <<<ENDOFTEXT

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>

<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /> 

<style type="text/css" media="all">

body {
     font-family: Verdana, Tahoma, Arial, sans-serif;
     font-size: 11px;
     color: #333333;
     font-weight: normal;
     text-align: left;
     background-color: #F5F5F5;
     margin: 20px;
     }

a {
     color: #30569D;
     text-decoration: none;
     font-weight: normal;
     }

a.alt {
     color: #FFFFFF;
     font-weight: normal;
     }

a:hover {
     text-decoration: underline;
     }

p.inline {
     display: inline;
     }

.strong {
     font-weight: bold;
     }

#header {
     background-color: #FFFFFF;
     width: 610px;
     border: 1px solid #333333;
     padding: 5px;
     margin: 10px auto 0px auto;
     }

#content {
     color: #333333;
     background-color: #FFFFFF;
     border-left: 1px solid #333333;
     border-right: 1px solid #333333;
     border-bottom: 1px solid #333333;
     width: 600px;
     padding: 10px;
     margin: auto;
     }

#info {
     color: #333333;
     background-color: #A5C9EF;
     border-left: 1px solid #333333;
     border-right: 1px solid #333333;
     border-bottom: 1px solid #333333;
     width: 600px;
     padding: 10px;
     margin: auto;
     }

#footer {
     color: #FFFFFF;
     background-color: #3872B2;
     border: 1px solid #333333;
     width: 600px;
     padding: 10px;
     margin: 10px auto 10px auto;
     }

#pgtitle {
     color: #FF6600;
     padding: 0px;
     margin: 0px 0px 10px 0px;
     font-weight: bold;
     font-size: 18px;
     }

</style> 

<title>Kryptronic Hybrid X Core (KHXC): Script Execution Error</title>

</head>

<body>

<div id="header"><img src="http://central.kryptronic.com/public/media/header_khxc.png" alt="KHXC" width="400" height="50" /></div>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_content                                      |
// +------------------------------------------------------------------+

function error_div_content ($errstr = '') {

// +--
// | This function prints the error contet.
// +--

$xhtml = <<<ENDOFTEXT

<div id="content">

<div id="pgtitle">Script Execution Error</div>

{$errstr}

</div>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_info                                         |
// +------------------------------------------------------------------+

function error_div_info ($errno = '',$errline = '',$errfile = '') {

// +--
// | This function prints the error info.
// +--

$xhtml = <<<ENDOFTEXT

<div id="info">

<p class="inline">File: {$errfile} Line: {$errline} Error Number: {$errno}</p>

</div>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | Function: error_div_footer                                       |
// +------------------------------------------------------------------+

function error_div_footer ($date_year = '') {

// +--
// | This function prints the error footer.
// +--

$xhtml = <<<ENDOFTEXT

<div id="footer">

<p class="inline">&copy; 1999-{$date_year} Kryptronic, Inc. All 
rights reserved worldwide. Kryptronic, the Kryptronic logo and all 
Kryptronic software names and logos are trademarks of Kryptronic, Inc.  
All Kryptronic software is copyrighted and the intellectual property of 
Kryptronic, Inc.  All Kryptronic software is developed and distributed 
under license by Kryptronic, Inc. Application Information: 

<a class="alt" href="http://www.kryptronic.com/" title="Kryptronic">http://www.kryptronic.com/</a></p>

</div>

</body>

</html>

ENDOFTEXT;

return $xhtml;

} // End of function.

// +------------------------------------------------------------------+
// | End of Class                                               [KHXC]|
// +------------------------------------------------------------------+

} // End of class.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Core Class                                              |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Class Definition: KHXCimporter                             [KHXC]|
// +------------------------------------------------------------------+

class KHXCimporter {

// +--
// | This class handles data imports into the KHXC  This script is to 
// | be considered standalone software and it's architecture and 
// | methodology are not indicative of the KHXC core codebase.  
// | Do not use code in this KHXCimporter class as a basis for KHXC
// | core or application code.
// +--

// +------------------------------------------------------------------+
// | Class Variables                                            [KHXC]|
// +------------------------------------------------------------------+

var $class   = 'KHXCimporter';
var $version = '1.0.0';
var $cerror;

var $dbrows_atonce = 100;

var $KHXC;
var $KHXC_Display;
var $KHXC_DB;
var $KHXC_DBX;
var $KHXC_Crypt;
var $KHXC_File;

// +------------------------------------------------------------------+
// | Constructor Function                                       [KHXC]|
// +------------------------------------------------------------------+

function KHXCimporter ($khxc_object = '') {

// +--
// | This is the constructor function.  This function starts up the
// | class.  Any pre-load variable assignments go here.
// +--

// +--
// | Define our KHXC object.
// +--

$this->KHXC =& $khxc_object;

// +--
// | Quick object load: KHXC_Display
// +--

$this->KHXC_Display =& $this->KHXC->quick_object('KHXC_Display','khxc');

if ($this->KHXC->IsError($this->KHXC_Display)) {$this->cerror = $this->KHXC_Display; return;}

// +--
// | Quick object load: KHXC_DB
// +--

$this->KHXC_DB =& $this->KHXC->quick_object('KHXC_DB','khxc','KHXC_DB_1');

if ($this->KHXC->IsError($this->KHXC_DB)) {$this->cerror = $this->KHXC_DB; return;}

// +--
// | Quick object load: KHXC_Crypt
// +--

$this->KHXC_Crypt =& $this->KHXC->quick_object('KHXC_Crypt','khxc');

if ($this->KHXC->IsError($this->KHXC_Crypt)) {$this->cerror = $this->KHXC_Crypt; return;}

// +--
// | Quick object load: KHXC_File
// +--

$this->KHXC_File =& $this->KHXC->quick_object('KHXC_File','khxc');

if ($this->KHXC->IsError($this->KHXC_File)) {$this->cerror = $this->KHXC_File; return;}

// +--
// | Return object.
// +--

return $this;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Wrapper                                                 |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: exec                                                   |
// +------------------------------------------------------------------+

function exec () {

// +--
// | This function runs the internals of the importer program.
// +--

// +--
// | Define some important variables.
// +--

$this->KHXC->globals('importer.numsteps','15');

// +--
// | Start buffering output.
// +--

if (!($this->KHXC->globals('importer.buffer_status'))) {

     @ob_start();

     $this->KHXC->globals('importer.buffer_status',1);

} // End of if statement.

// +--
// | Start processing.
// +--

$result = $this->exec_do();

if ($this->KHXC->IsError($result)) {

     trigger_error($result->GetMessage(),E_USER_ERROR);

} // End of if statement.

// +--
// | Finish buffering output.
// +--

if ($this->KHXC->globals('importer.buffer_status')) {

     $buffered_output = @ob_get_contents();

     @ob_end_clean();

     $this->KHXC->globals('importer.buffered_output',$buffered_output);

     $this->KHXC->globals('importer.buffer_status',0);

} // End of if statement.

// +--
// | Kill the buffering in the KHXC and set our display status to
// | false.
// +--

$this->KHXC_Display->buffer('CLEAN');

$this->KHXC->globals('khxc.output',0);

// +--
// | Print the display.
// +--

$this->disp();

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: exec_do                                                |
// +------------------------------------------------------------------+

function exec_do () {

// +--
// | This function processes the main logic of the importer.
// +--

// +--
// | Define the step we're on.
// +--

$step = $this->KHXC->globals('khxc_cgi.step');

if (!($step)) {$step = 'Intro';}

// +--
// | Get password info from form input and present the right 
// | interface.
// +--

$password = $this->KHXC->globals('khxc.password');

if (!(empty($password))) {

     $import_password = $this->KHXC->globals('khxc_cgi.import_password');

     if (!($import_password)) {

          $step = 'Password';

     } elseif (md5($import_password) != $password) {

          $message = "The password you entered is incorrect.  Please try again.";
          $step    = 'Password';

          $this->disp_message($message,'ERROR');

     } // End of if statement.

} elseif ($step != 'IntroP') {

     $step = 'Intro';

} // End of if statement.

// +--
// | Check the status of our license agreement acceptance.
// +--

$license_agree = $this->KHXC->globals('khxc_cgi.license_agree');

if (empty($license_agree)) {

          if ($step != 'Password' && $step != 'Intro') {

          $message = "You did not agree to the terms and conditions in the EULA.  
                      You must agree to these terms and conditions to continue.";

          if ($step == 'IntroP') {$step = 'Intro';}

          else {$step = 'Password';}

          $this->disp_message($message,'ERROR');

     } // End of if statement.

} // End of if statement.

// +--
// | Execute our step.
// +--

$result = $this->exec_step($step);

if ($this->KHXC->IsError($result)) {return $result;}

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: exec_step                                              |
// +------------------------------------------------------------------+

function exec_step ($step = 'Default') {

// +--
// | This function executes importer steps.
// +--

// +--
// | Use the step to figure out what we need to be doing.  If the
// | step is blank, we default to step I.  A list of the steps is
// | below:
// |
// | Step Number  Action          
// | -----------  -------------------
// | Default      Default Invalid Info Screen
// | Password     Password Collection
// | Location     Installation Location
// | LocationP    Installation Location - Process
// | Settings     Software Settings
// | SettingsP    Software Settings - Process
// | Media        Media Files
// | MediaP       Media Files - Process
// | CustAcct     Customer Accounts
// | CustAcctP    Customer Accounts - Processs
// | Affiliates   Affiliate Accounts 
// | AffiliatesP  Affiliate Accounts - Process
// | Maillist     Maillist Accounts
// | MaillistP    Maillist Accounts - Process
// | Category     Categories
// | CategoryP    Categories - Process
// | Product      Products
// | ProductP     Products - Process
// | ProdOpt      Product Options
// | ProdOptP     Product Options - Process
// | DynForm      Dynamic Forms
// | DynFormP     Dynamic Forms - Process
// | Orders       Orders
// | OrdersP      Orders - Process
// | OrderItems   OrderItems
// | OrderItemsP  OrderItems - Process
// | Discounts    Discount Codes
// | DiscountsP   Discount Codes - Process
// | HtmlPage     HTML Pages (User Defined)
// | HtmlPageP    HTML Pages (User Defined) - Process
// | Skin         Display Skin
// | SkinP        Display Skin - Process
// | Final        Final Confirm Display
// +--

switch ($step) {

     case "Password":
          $result = $this->step_Password();
          break;

     case "Location":
          $result = $this->step_Location();
          break;

     case "LocationP":
          $result = $this->step_LocationP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Location();
          }
          break;

     case "Settings":
          $result = $this->step_Settings();
          break;

     case "SettingsP":
          $result = $this->step_SettingsP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Settings();
          }
          break;

     case "Media":
          $result = $this->step_Media();
          break;

     case "MediaP":
          $result = $this->step_MediaP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Media();
          }
          break;

     case "CustAcct":
          $result = $this->step_CustAcct();
          break;

     case "CustAcctP":
          $result = $this->step_CustAcctP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_CustAcct();
          }
          break;

     case "Affiliates":
          $result = $this->step_Affiliates();
          break;

     case "AffiliatesP":
          $result = $this->step_AffiliatesP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Affiliates();
          }
          break;

     case "Maillist":
          $result = $this->step_Maillist();
          break;

     case "MaillistP":
          $result = $this->step_MaillistP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Maillist();
          }
          break;

     case "Category":
          $result = $this->step_Category();
          break;

     case "CategoryP":
          $result = $this->step_CategoryP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Category();
          }
          break;

     case "Product":
          $result = $this->step_Product();
          break;

     case "ProductP":
          $result = $this->step_ProductP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Product();
          }
          break;

     case "ProdOpt":
          $result = $this->step_ProdOpt();
          break;

     case "ProdOptP":
          $result = $this->step_ProdOptP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_ProdOpt();
          }
          break;

     case "DynForm":
          $result = $this->step_DynForm();
          break;

     case "DynFormP":
          $result = $this->step_DynFormP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_DynForm();
          }
          break;

     case "Orders":
          $result = $this->step_Orders();
          break;

     case "OrdersP":
          $result = $this->step_OrdersP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Orders();
          }
          break;

     case "OrderItems":
          $result = $this->step_OrderItems();
          break;

     case "OrderItemsP":
          $result = $this->step_OrderItemsP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_OrderItems();
          }
          break;

     case "Discounts":
          $result = $this->step_Discounts();
          break;

     case "DiscountsP":
          $result = $this->step_DiscountsP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Discounts();
          }
          break;

     case "HtmlPage":
          $result = $this->step_HtmlPage();
          break;

     case "HtmlPageP":
          $result = $this->step_HtmlPageP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_HtmlPage();
          }
          break;

     case "Skin":
          $result = $this->step_Skin();
          break;

     case "SkinP":
          $result = $this->step_SkinP();
          if ($this->KHXC->IsError($result)) {
               $this->disp_message($result->GetMessage(),'ERROR');
               return $this->step_Skin();
          }
          break;

     case "Final":
          $result = $this->step_Final();
          break;

     default:
          $result = $this->step_Default();
          break;

} // End of switch statement.

// +--
// | Return the result.
// +--

return $result;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Steps                                                   |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: step_Default                                           |
// +------------------------------------------------------------------+

function step_Default () {

// +--
// | Importer Function Step.
// +--

// +--
// | Default Invalid Info Screen
// | 
// | This function prints a page indicating the importer was hit 
// | with invalid information and prints a valid importer link.
// +--

$insname = $this->KHXC->globals('importer.script_name');

print <<<ENDOFTEXT

<p>You have accessed this importer script using invalid data.  In 
order to use the importer script, please follow the link below:</p>

<p><a href="{$insname}" title="importer">Click here to run the importer script.</a></p>

ENDOFTEXT;

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Password                                          |
// +------------------------------------------------------------------+

function step_Password () {

// +--
// | Importer Function Step.
// +--

// +--
// | Password Collection
// | 
// | This function prints a form to be completed by the user to 
// | submit a password for this importer script.  This screen is 
// | accessed when a password already exists for the importer.
// +--

$software = $this->KHXC->globals('importer.name');

print <<<ENDOFTEXT

<p>This data importer script is designed to import data from a {$software} 
installation into the Kryptronic Hybrid X Core (KHXC) database which this 
script is currenly associated with.</p>

<p><strong>Items that are imported by this script</strong>: 
Settings, media files, customer accounts, mail list accounts, affiliate accounts, 
categories, products, product options, dynamic forms, orders, discount codes, 
custom checkout fields, HTML pages (user defined) and the display skin.</p>

<p><strong>Items that are not imported by this script</strong>:  
Online processing settings, realtime shipping configuration information, 
custom shipping scripts, checkout form modifications and general display 
changes made to HTML elements.</p>

<p><strong>Please Note</strong>: If you have configured a Relational 
Database Management System (RDBMS) connection within your {$software} 
installation, that data source will be used for any tables you have exported 
to the RDBMS.  The access information needed to connect to that RDBMS will 
be automatically pulled from your {$software} installation.  There is no 
need to enter that information into this importer script.</p>

ENDOFTEXT;

// +--
// | Define the form.
// +--

$header = <<<ENDOFTEXT

<p>This importer script is protected by a password that was set up
during the initial installation of this program.  Enter the password 
you selected to protect the installer script below then click the 
'Continue' button at the bottom of this page to import data using this 
importer script.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_password';
$fields[0]['name']     = 'Installer Password';
$fields[0]['type']     = 'PASSWORD';
$fields[0]['required'] = '1';

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Enter the password below that you selected to permit controlled 
access to the KHXC installer.  If you do not remember the installer password 
you selected during the initial installation of this program, edit the 
'config.php' file in this directory.  Delete the MD5 hash assigned to the 
'khxc.password' variable to create a new password.</p>

ENDOFTEXT;

$fields[1]['id']       = 'license_agree';
$fields[1]['name']     = 'License Agreement';
$fields[1]['type']     = 'CHECKBOX';
$fields[1]['required'] = '1';
$fields[1]['values']   = array('1' => 'I agree to the terms and conditions in the EULA.');

$fields[1]['desc']     = <<<ENDOFTEXT

<p>Installation and use of this program requires you read and accept the 
End User License Agreement (EULA) distributed with this software.  Follow 
the link below to review the EULA.  The EULA is distributed in Adobe PDF 
format.  You will need Acrobat Reader, which is freely available from Adobe, 
to review the EULA.</p>

<p><a href="license.pdf" rel="external" title="License">Click here to review the EULA.</a></p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'Location'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Location                                          |
// +------------------------------------------------------------------+

function step_Location () {

// +--
// | Importer Function Step: 
// |
// | Installation Location & Destination Application
// +--

$this->KHXC->globals('importer.step','1');
$this->KHXC->globals('importer.steptext','Installation Location &amp; Destination Application');

// +--
// | Get a list of ecommerce applications we can import into.
// +--

$sql  = "SELECT id, name FROM khxc_apps WHERE id<>";
$sql .= $this->KHXC_DB->quote('khxc');

$result = $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                       'table' => 'khxc_apps',
                                       'order' => array('id' => 'ASC')));

if ($this->KHXC->IsError($result)) {

     $message  = "An error was encountered while attempting to retrieve a 
                  list of installed applications.  The error returned was: ";

     $message .= $result->GetMessage();

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

if (empty($result)) {

     $message  = "This importer script was unable to retrieve information on 
                  any installed applications.  An application needs to be 
                  installed in order to use this importer.";

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

foreach ($result as $num => $row) {

     $apps_array[$row['id']] = $row['name'] . ' (' . $row['id'] . ')';

} // End of foreach statement.

// +--
// | Print the form.
// +--

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below the destination application for this data import and the server 
paths for the data and media directories for your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_destapp';
$fields[0]['name']     = 'Destination Application';
$fields[0]['type']     = 'SELECT';
$fields[0]['required'] = '1';
$fields[0]['values']   = $apps_array;

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Select the application into which you would like data imported.  The application you 
select should be an e-commerce application.</p>

ENDOFTEXT;

$fields[1]['id']       = 'import_dirdata';
$fields[1]['name']     = 'Source Data Directory Path';
$fields[1]['type']     = 'TEXT-LONG';
$fields[1]['required'] = '1';

$fields[1]['desc']     = <<<ENDOFTEXT

<p>Enter the absolute directory path to the data directory used by your 
{$software} installation.  If you do not know what your directory path 
is, you can locate it in your {$software} cp-app.cgi or cp-app.pl file.  It 
is assigned in that file to the variable \$server_data_path.</p>

<p>Example: /home/username/ccp51/data or C:/Inetpub/db/ccp51</p>

ENDOFTEXT;

$fields[2]['id']       = 'import_dirmedia';
$fields[2]['name']     = 'Source Media Directory Path';
$fields[2]['type']     = 'TEXT-LONG';
$fields[2]['required'] = '1';

$fields[2]['desc']     = <<<ENDOFTEXT

<p>Enter the absolute directory path to the media directory used by your 
{$software} installation.  If you do not know what your directory path 
is, you can locate it in your {$software} cp-app.cgi or cp-app.pl file.  It 
is assigned in that file to the variable \$server_media_path.</p>

<p>Example: /home/username/www/ccp51/media or C:/Inetpub/wwwroot/ccp51/media</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'LocationP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_LocationP                                         |
// +------------------------------------------------------------------+

function step_LocationP () {

// +--
// | Importer Function Step: 
// |
// | Installation Location & Destination Application - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Strip off any trailing slashes and convert to Unix style
// | paths/filenames.
// +--

$import_dirdata  = $this->KHXC->paths_convert($fd['import_dirdata']);
$import_dirmedia = $this->KHXC->paths_convert($fd['import_dirmedia']);

$this->KHXC->globals('khxc_cgi.import_dirdata',$import_dirdata);
$this->KHXC->globals('khxc_cgi.import_dirmedia',$import_dirmedia);

// +--
// | Check the formdata submission items and append error messages as
// | we go.
// +--

$errorcount = 0;

$errmsg     = "The following errors were encountered while attempting 
               to process your request: ";

// +--
// | Check the data directory.
// +--

if (!(@file_exists($import_dirdata . '/tables'))) {

     $errorcount++;

     $errmsg .= " {$errorcount}. The directory path for the data directory used by your
                 software installation is incorrect.  The path specified does not 
                 appear to contain any software installation files.";

} // End of if statement.

// +--
// | Check the media directory.
// +--

if (!(@file_exists($import_dirmedia . '/images'))) {

     $errorcount++;

     $errmsg .= " {$errorcount}. The directory path for the media directory used by your
                 software installation is incorrect.  The path specified does not 
                 appear to contain any software installation files.";

} // End of if statement.

// +--
// | Return errors if we have any at this point.
// +--

if ($errorcount) {

     $result = $this->KHXC->RaiseError($errmsg);

     return $result;

} // End of if statement.

// +--
// | Print a confirmation message.
// +--

$message = "Thank you. The destination application and your source directory paths 
            have been validated.  You can now continue through the import process.";

$this->disp_message($message,'CONFIRM');

// +--
// | Go to the next step.
// +--

return $this->step_Settings();

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Settings                                          |
// +------------------------------------------------------------------+

function step_Settings () {

// +--
// | Importer Function Step: 
// |
// | Software Settings Import
// +--

$this->KHXC->globals('importer.step','2');
$this->KHXC->globals('importer.steptext','Software Settings Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import settings from your {$software} 
installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Software Settings Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import settings from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the settings from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'SettingsP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_SettingsP                                         |
// +------------------------------------------------------------------+

function step_SettingsP () {

// +--
// | Importer Function Step: 
// |
// | Software Settings Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing settings.  No 
                 settings have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Media();

} // End of if statement.

// +--
// | Load the settings.
// +--

$settings1 = $this->import_load_settings('settings.csv');

if ($this->KHXC->IsError($settings1)) {return $settings1;}

$settings2 = $this->import_load_settings('accounting.csv');

if ($this->KHXC->IsError($settings2)) {return $settings2;}

$settings = array_merge($settings1,$settings2);

// +--
// | Create our translation array.
// +--

$translation = array();

$translation['site_owner_name']                    = array('dest' => 'site_name', 'filter' => '', 'dvalue' => '');
$translation['site_owner_address']                 = array('dest' => 'siteowneradd', 'filter' => '', 'dvalue' => '');
$translation['site_owner_city']                    = array('dest' => 'siteownercity', 'filter' => '', 'dvalue' => '');
$translation['site_owner_stateprov']               = array('dest' => 'siteownerstateprov', 'filter' => '', 'dvalue' => '');
$translation['site_owner_zip']                     = array('dest' => 'siteownerzip', 'filter' => '', 'dvalue' => '');
$translation['site_owner_country']                 = array('dest' => 'siteownercountry', 'filter' => 'country', 'dvalue' => '');
$translation['site_owner_phone']                   = array('dest' => 'siteownerphone', 'filter' => '', 'dvalue' => '');
$translation['site_owner_fax']                     = array('dest' => 'siteownerfax', 'filter' => '', 'dvalue' => '');
$translation['site_owner_email_address']           = array('dest' => 'default_contact_email', 'filter' => '', 'dvalue' => '');
$translation['html_site_name']                     = array('dest' => 'site_name', 'filter' => '', 'dvalue' => '');
$translation['site_order_email_prim']              = array('dest' => 'primordemail', 'filter' => '', 'dvalue' => '');
$translation['store_send_email_prim']              = array('dest' => 'primordemailsend', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['site_order_email_sec']               = array('dest' => 'ccordemail', 'filter' => '', 'dvalue' => '');
$translation['store_noncat_catcount']              = array('dest' => 'splashcatnum', 'filter' => '', 'dvalue' => '');
$translation['store_noncat_smcount']               = array('dest' => 'splashprodnum', 'filter' => '', 'dvalue' => '');
$translation['store_new_smcount']                  = array('dest' => 'newprodnum', 'filter' => '', 'dvalue' => '');
$translation['store_best_smcount']                 = array('dest' => 'bestprodnum', 'filter' => '', 'dvalue' => '');
$translation['store_specials_smcount']             = array('dest' => 'specprodnum', 'filter' => '', 'dvalue' => '');
$translation['store_products_to_display_per_page'] = array('dest' => 'proddisppg', 'filter' => '', 'dvalue' => '');
$translation['store_disable_store']                = array('dest' => 'disablestore', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['store_disp_prodnums']                = array('dest' => 'dispprodnums', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['store_use_email_a_friend']           = array('dest' => 'emailfriend', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['store_use_relatedprods']             = array('dest' => 'relatedprods', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['salescript_use']                     = array('dest' => 'usesalescript', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['store_minorder_amt']                 = array('dest' => 'minorderamt', 'filter' => '', 'dvalue' => '');
$translation['order_number_type']                  = array('dest' => 'ordernumtype', 'filter' => '', 'dvalue' => '');
$translation['order_number_prefix']                = array('dest' => 'ordernumprefix', 'filter' => '', 'dvalue' => '');
$translation['store_small_image_width']            = array('dest' => 'imgsizeprodsm', 'filter' => '', 'dvalue' => '');
$translation['store_cat_image_width']              = array('dest' => 'imgsizecat', 'filter' => '', 'dvalue' => '');
$translation['store_large_image_width']            = array('dest' => 'imgsizeprodlg', 'filter' => '', 'dvalue' => '');
$translation['ship_real_error_weight']             = array('dest' => 'shipminweight', 'filter' => '', 'dvalue' => '');
$translation['ship_real_error_length']             = array('dest' => 'shipminlength', 'filter' => '', 'dvalue' => '');
$translation['ship_real_error_width']              = array('dest' => 'shipminwidth', 'filter' => '', 'dvalue' => '');
$translation['ship_real_error_height']             = array('dest' => 'shipminheight', 'filter' => '', 'dvalue' => '');
$translation['ship_real_error_dimstatusw']         = array('dest' => 'presdimerr', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['ship_real_error_dimstatusd']         = array('dest' => 'presweighterr', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['ship_def_error_name']                = array('dest' => 'shiperrname', 'filter' => '', 'dvalue' => '');
$translation['ship_def_error_price']               = array('dest' => 'shiperramt', 'filter' => '', 'dvalue' => '');
$translation['ship_def_handle']                    = array('dest' => 'shiphandlecharge', 'filter' => '', 'dvalue' => '');
$translation['remote_html_post_use']               = array('dest' => 'ecomremoteactive', 'filter' => 'yn2bool', 'dvalue' => '');
$translation['remote_html_post_url']               = array('dest' => 'ecomremoteurls', 'filter' => '', 'dvalue' => '');
$translation['pt_acctrec']                         = array('dest' => 'ptacctrec', 'filter' => '', 'dvalue' => '');
$translation['pt_expdisc']                         = array('dest' => 'ptexpdisc', 'filter' => '', 'dvalue' => '');
$translation['pt_expdiscd']                        = array('dest' => 'ptexpdiscd', 'filter' => '', 'dvalue' => '');
$translation['pt_expdisct']                        = array('dest' => 'ptexpdisct', 'filter' => '', 'dvalue' => '');
$translation['pt_expsale']                         = array('dest' => 'ptexpsale', 'filter' => '', 'dvalue' => '');
$translation['pt_expsaled']                        = array('dest' => 'ptexpsaled', 'filter' => '', 'dvalue' => '');
$translation['pt_expsalet']                        = array('dest' => 'ptexpsalet', 'filter' => '', 'dvalue' => '');
$translation['pt_incitem']                         = array('dest' => 'ptincitem', 'filter' => '', 'dvalue' => '');
$translation['pt_incitemt']                        = array('dest' => 'ptincitemt', 'filter' => '', 'dvalue' => '');
$translation['pt_incship']                         = array('dest' => 'ptincship', 'filter' => '', 'dvalue' => '');
$translation['pt_incshipd']                        = array('dest' => 'ptincshipd', 'filter' => '', 'dvalue' => '');
$translation['pt_incshipt']                        = array('dest' => 'ptincshipt', 'filter' => '', 'dvalue' => '');
$translation['pt_inctaxc']                         = array('dest' => 'ptinctaxc', 'filter' => '', 'dvalue' => '');
$translation['pt_inctaxcd']                        = array('dest' => 'ptinctaxcd', 'filter' => '', 'dvalue' => '');
$translation['pt_inctaxct']                        = array('dest' => 'ptinctaxct', 'filter' => '', 'dvalue' => '');
$translation['pt_inctaxs']                         = array('dest' => 'ptinctaxs', 'filter' => '', 'dvalue' => '');
$translation['pt_inctaxsd']                        = array('dest' => 'ptinctaxsd', 'filter' => '', 'dvalue' => '');
$translation['pt_inctaxst']                        = array('dest' => 'ptinctaxst', 'filter' => '', 'dvalue' => '');
$translation['pt_payment']                         = array('dest' => 'ptpayment', 'filter' => '', 'dvalue' => '');
$translation['pt_paymentd']                        = array('dest' => 'ptpaymentd', 'filter' => '', 'dvalue' => '');
$translation['pt_paymentt']                        = array('dest' => 'ptpaymentt', 'filter' => '', 'dvalue' => '');
$translation['qb_acctrec']                         = array('dest' => 'qbacctrec', 'filter' => '', 'dvalue' => '');
$translation['qb_bankacc']                         = array('dest' => 'qbbankacc', 'filter' => '', 'dvalue' => '');
$translation['qb_expdisc']                         = array('dest' => 'qbexpdisc', 'filter' => '', 'dvalue' => '');
$translation['qb_expdiscd']                        = array('dest' => 'qbexpdiscd', 'filter' => '', 'dvalue' => '');
$translation['qb_expsale']                         = array('dest' => 'qbexpsale', 'filter' => '', 'dvalue' => '');
$translation['qb_expsaled']                        = array('dest' => 'qbexpsaled', 'filter' => '', 'dvalue' => '');
$translation['qb_incitem']                         = array('dest' => 'qbincitem', 'filter' => '', 'dvalue' => '');
$translation['qb_incship']                         = array('dest' => 'qbincship', 'filter' => '', 'dvalue' => '');
$translation['qb_incshipd']                        = array('dest' => 'qbincshipd', 'filter' => '', 'dvalue' => '');
$translation['qb_inctaxc']                         = array('dest' => 'qbinctaxc', 'filter' => '', 'dvalue' => '');
$translation['qb_inctaxcd']                        = array('dest' => 'qbinctaxcd', 'filter' => '', 'dvalue' => '');
$translation['qb_inctaxs']                         = array('dest' => 'qbinctaxs', 'filter' => '', 'dvalue' => '');
$translation['qb_inctaxsd']                        = array('dest' => 'qbinctaxsd', 'filter' => '', 'dvalue' => '');

// CCP51-UK Vat Settings.
$translation['manage_vat']                         = array('dest' => 'manageeutax', 'filter' => 'manage_vat', 'dvalue' => '');
$translation['vat_no']                             = array('dest' => 'eutaxregno', 'filter' => '', 'dvalue' => '');
$translation['vat_rebate']                         = array('dest' => 'eutaxrebatetype', 'filter' => 'vat_rebate', 'dvalue' => '');
$translation['vat_shipping']                       = array('dest' => 'eutaxonshipping', 'filter' => 'vat_shipping', 'dvalue' => '');

// +--
// | Set up our table.
// +--

$app = $this->KHXC->globals('khxc_cgi.import_destapp');

$table = 'khxc_settings';

// +--
// | Work with the translation array.
// +--

foreach ($translation as $key => $info) {

     if (isset($settings[$key])) {

          $value = $settings[$key];

          if (!(empty($info['dvalue']))) {$value = $info['dvalue'];}
          if (!(empty($info['filter']))) {$value = $this->import_filter($info['filter'],$value,$settings);}

          $data = array('value' => "$value");

          $update_clause = $this->KHXC_DB->clause_update(array('table'      => 'khxc_settings',
                                                               'data'       => $data));

         if (!($this->KHXC->IsError($update_clause))) {

              $sql = $update_clause . " WHERE id=" . $this->KHXC_DB->quote($app . '.' . $info['dest']);


              $result = $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                                     'table' => 'khxc_settings'));

         } // End of if statement.

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print a confirmation message.
// +--

$message = "Thank you. Settings have been imported.  You can now continue 
            through the import process.";

$this->disp_message($message,'CONFIRM');

// +--
// | Go to the next step.
// +--

return $this->step_Media();

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Media                                             |
// +------------------------------------------------------------------+

function step_Media () {

// +--
// | Importer Function Step: 
// |
// | Media File Import
// +--

$this->KHXC->globals('importer.step','3');
$this->KHXC->globals('importer.steptext','Media File Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import media files from your {$software} 
installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Media File Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import media files from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the media files from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'MediaP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_MediaP                                            |
// +------------------------------------------------------------------+

function step_MediaP () {

// +--
// | Importer Function Step: 
// |
// | Media File Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing media files.  No 
                 files have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_CustAcct();

} // End of if statement.

// +--
// | Handle importing the data.
// +--

$app         = $this->KHXC->globals('khxc_cgi.import_destapp');

$dirdlsrc    = $this->KHXC->globals('khxc_cgi.import_dirdata')  . '/downloads';
$dirimgs     = $this->KHXC->globals('khxc_cgi.import_dirmedia') . '/images';
$destdlsrc   = $this->KHXC->globals('khxc.path_private') . '/downloads';
$destimgs    = $this->KHXC->globals('khxc.path_public') . '/media/' . $app;

$translation = array($dirdlsrc                      => $destdlsrc,
                     $dirimgs . '/category'         => $destimgs . '/cat',
                     $dirimgs . '/product_category' => $destimgs . '/prodsm',
                     $dirimgs . '/product_detail'   => $destimgs . '/prodlg',
                     $dirimgs . '/product_xlarge'   => $destimgs . '/prodxl',
                     $dirimgs . '/site'             => $destimgs . '/html',
                     $dirimgs . '/store'            => $destimgs . '/html',
                     $dirimgs . '/banner'           => $destimgs . '/html');

foreach ($translation as $source => $dest) {

     $files  = array();

     $handle = @opendir($source);

     if (!(empty($handle))) {

          while (false !== ($file = @readdir($handle))) {

               if (($file != 'dir.txt') && ($file != 'index.htm') && ($file != 'default.htm') && (is_file($source . '/' . $file))) {

                    if (!(file_exists($dest . '/' . $file))) {

                         $this->KHXC_File->copy(array('source' => $source . '/' . $file,
                                                      'dest'   => $dest . '/' . $file));

                    } // End of if statement.

               } // End of if statement.

          } // End of while statement.

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print a confirmation message.
// +--

$message = "Thank you. Media files have been imported.  You can now continue 
            through the import process.";

$this->disp_message($message,'CONFIRM');

// +--
// | Go to the next step.
// +--

return $this->step_CustAcct();

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustAcct                                          |
// +------------------------------------------------------------------+

function step_CustAcct () {

// +--
// | Importer Function Step: 
// |
// | Customer Account Import
// +--

$this->KHXC->globals('importer.step','4');
$this->KHXC->globals('importer.steptext','Customer Account Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import customer accounts from your {$software} 
installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Customer Account Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import customer accounts from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the customer accounts from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'CustAcctP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CustAcctP                                         |
// +------------------------------------------------------------------+

function step_CustAcctP () {

// +--
// | Importer Function Step: 
// |
// | Customer Account Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing customer accounts.  No 
                 accounts have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Affiliates();

} // End of if statement.

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->KHXC->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('custacct',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'CustAcctP';
$mtinfo['currtask']   = 'Customer Account Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('custacct',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']               = array('source' => 'custacct_id', 'filter' => 'strtolower', 'dvalue' => '');
     $translation['password']         = array('source' => 'custacct_pass', 'filter' => 'password', 'dvalue' => '');
     $translation['usergroup']        = array('source' => 'users', 'filter' => '', 'dvalue' => 'users');
     $translation['fname']            = array('source' => 'custacct_firstname', 'filter' => '', 'dvalue' => '');
     $translation['lname']            = array('source' => 'custacct_lastname', 'filter' => '', 'dvalue' => '');
     $translation['lastaccess']       = array('source' => 'custacct_epoch', 'filter' => '', 'dvalue' => '');
     $translation['company']          = array('source' => 'custacct_company', 'filter' => '', 'dvalue' => '');
     $translation['phone']            = array('source' => 'custacct_phone', 'filter' => '', 'dvalue' => '');
     $translation['fax']              = array('source' => 'custacct_fax', 'filter' => '', 'dvalue' => '');
     $translation['addone']           = array('source' => 'custacct_addressone', 'filter' => '', 'dvalue' => '');
     $translation['addtwo']           = array('source' => 'custacct_addresstwo', 'filter' => '', 'dvalue' => '');
     $translation['city']             = array('source' => 'custacct_city', 'filter' => '', 'dvalue' => '');
     $translation['stateprov']        = array('source' => 'custacct_stateprov', 'filter' => '', 'dvalue' => '');
     $translation['country']          = array('source' => 'custacct_country', 'filter' => 'country', 'dvalue' => '');
     $translation['postalcode']       = array('source' => 'custacct_zip', 'filter' => '', 'dvalue' => '');
     $translation['rescom']           = array('source' => 'custacct_rescom', 'filter' => '', 'dvalue' => '');
     $translation['subscriptions']    = array('source' => '', 'filter' => '', 'dvalue' => '1');

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if (!(empty($info['dvalue']))) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Address book
          // +--

          if (!(empty($row['custacct_shipfirstname']))) {

               $addbook = array();

               $xbook = array('fname'      => $row['custacct_shipfirstname'],
                              'lname'      => $row['custacct_shiplastname'],
                              'company'    => $row['custacct_shipcompany'],
                              'addone'     => $row['custacct_shipaddressone'],
                              'addtwo'     => $row['custacct_shipaddresstwo'],
                              'city'       => $row['custacct_shipcity'],
                              'stateprov'  => $row['custacct_shipstateprov'],
                              'country'    => $row['custacct_shipcountry'],
                              'postalcode' => $row['custacct_shipzip'],
                              'rescom'     => $row['custacct_shiprescom']);

               $hash           = md5(serialize($xbook));
               $addbook[$hash] = $xbook;
               $addbook        = serialize($addbook);

               $insert['addbook'] = $addbook;

          } // End of if statement.

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->KHXC_DB->clause_insert(array('table' => 'khxc_users',
                                                     'data'  => $insert));

          if (!($this->KHXC->IsError($sql))) {

               $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'khxc_users'));

          } // End of if statement.


     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Customer accounts have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Affiliates();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Affiliates                                        |
// +------------------------------------------------------------------+

function step_Affiliates () {

// +--
// | Importer Function Step: 
// |
// | Affiliate Account Import
// +--

$this->KHXC->globals('importer.step','5');
$this->KHXC->globals('importer.steptext','Affiliate Account Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import affiliate accounts from your {$software} 
installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Affiliate Account Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import affiliate accounts from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the affiliate accounts from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'AffiliatesP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_AffiliatesP                                       |
// +------------------------------------------------------------------+

function step_AffiliatesP () {

// +--
// | Importer Function Step: 
// |
// | Affiliate Account Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing affiliate accounts. 
                 No accounts have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_MailList();

} // End of if statement.

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->KHXC->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('affacct',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'AffiliatesP';
$mtinfo['currtask']   = 'Affiliate Account Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('affacct',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']               = array('source' => 'affacct_email', 'filter' => 'strtolower', 'dvalue' => '');
     $translation['password']         = array('source' => 'affacct_pass', 'filter' => 'password', 'dvalue' => '');
     $translation['usergroup']        = array('source' => '', 'filter' => '', 'dvalue' => 'affiliate');
     $translation['fname']            = array('source' => 'affacct_firstname', 'filter' => '', 'dvalue' => '');
     $translation['lname']            = array('source' => 'affacct_lastname', 'filter' => '', 'dvalue' => '');
     $translation['lastaccess']       = array('source' => '', 'filter' => '', 'dvalue' => $this->KHXC->globals('khxc_datetime.epoch'));
     $translation['company']          = array('source' => 'affacct_company', 'filter' => '', 'dvalue' => '');
     $translation['phone']            = array('source' => 'affacct_phone', 'filter' => '', 'dvalue' => '');
     $translation['fax']              = array('source' => 'affacct_fax', 'filter' => '', 'dvalue' => '');
     $translation['addone']           = array('source' => 'affacct_addressone', 'filter' => '', 'dvalue' => '');
     $translation['addtwo']           = array('source' => 'affacct_addresstwo', 'filter' => '', 'dvalue' => '');
     $translation['city']             = array('source' => 'affacct_city', 'filter' => '', 'dvalue' => '');
     $translation['stateprov']        = array('source' => 'affacct_stateprov', 'filter' => '', 'dvalue' => '');
     $translation['country']          = array('source' => 'affacct_country', 'filter' => 'country', 'dvalue' => '');
     $translation['postalcode']       = array('source' => 'affacct_zip', 'filter' => '', 'dvalue' => '');
     $translation['rescom']           = array('source' => 'affacct_rescom', 'filter' => '', 'dvalue' => '');
     $translation['subscriptions']    = array('source' => '', 'filter' => '', 'dvalue' => '1');
     $translation['affilid']          = array('source' => 'affacct_id', 'filter' => '', 'dvalue' => '');
     $translation['affilsalestodate'] = array('source' => 'affacct_salestd', 'filter' => '', 'dvalue' => '');
     $translation['affilcommearned']  = array('source' => 'affacct_commearntd', 'filter' => '', 'dvalue' => '');
     $translation['affilcommpaid']    = array('source' => 'affacct_commpaidtd', 'filter' => '', 'dvalue' => '');

     foreach ($data as $num => $row) {

          // +--
          // | Only do active affiliates.
          // +--

          if ($row['affacct_active'] == 'Y') {

               $insert = array();

               // +--
               // | STANDARD: Translated data
               // +--

               foreach ($translation as $key => $info) {

                    $insert[$key] = $row[$info['source']];

                    if (!(empty($info['dvalue']))) {$insert[$key] = $info['dvalue'];}
                    if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

                    $insert[$key] = "{$insert[$key]}";

               } // End of foreach statement.

               // +--
               // | SPECIAL: Commission rate & commission owed
               // +--

               $insert['affilcommowed'] = $row['affacct_commearntd'] - $row['affacct_commpaidtd'];

               if ($insert['affilcommowed'] <= 0) {$insert['affilcommowed'] = '0.00';}

               if ($row['affacct_typemain'] == 'PCT') {$insert['affilcommpct'] = $row['affacct_valuemain'];}
               else                                   {$insert['affilcommpct'] = '0.000';}

               // +--
               // | Do a save.  This will update any existing user accounts with the new
               // | affiliate info.
               // +--

               $where = 'id=' . $this->KHXC_DB->quote($insert['id']) . ' AND usergroup=' . $this->KHXC_DB->quote('users');

               $this->KHXC_DB->sql_save(array('table'  => 'khxc_users',
                                              'where'  => $where,
                                              'data'   => $insert,
                                              'update' => '*'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Affiliate accounts have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_MailList();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Maillist                                          |
// +------------------------------------------------------------------+

function step_Maillist () {

// +--
// | Importer Function Step: 
// |
// | Mail List Import
// +--

$this->KHXC->globals('importer.step','6');
$this->KHXC->globals('importer.steptext','Mail List Subscriber Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import mail list subscribers from 
your {$software} installation.  If you choose to import mail list subscribers, 
customer accounts will be created for them and random passwords will be assigned 
to each account created.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Mail List Subscriber Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import mail list subscribers from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the mail list subscribers from your {$software} 
installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'MaillistP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_MaillistP                                         |
// +------------------------------------------------------------------+

function step_MaillistP () {

// +--
// | Importer Function Step: 
// |
// | Mail List Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing mail list subscribers. 
                 No subscribers have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Category();

} // End of if statement.

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->KHXC->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('maillist',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'MaillistP';
$mtinfo['currtask']   = 'Mail List Subscriber Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('maillist',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']               = array('source' => 'maillist_id', 'filter' => 'strtolower', 'dvalue' => '');
     $translation['usergroup']        = array('source' => 'users', 'filter' => '', 'dvalue' => 'users');
     $translation['fname']            = array('source' => 'maillist_fname', 'filter' => '', 'dvalue' => '');
     $translation['lname']            = array('source' => 'maillist_lname', 'filter' => '', 'dvalue' => '');
     $translation['lastaccess']       = array('source' => '', 'filter' => '', 'dvalue' => $this->KHXC->globals('khxc_datetime.epoch'));
     $translation['subscriptions']    = array('source' => '', 'filter' => '', 'dvalue' => '1');

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if (!(empty($info['dvalue']))) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Password
          // +--

          $insert['password'] = md5($this->KHXC->random_key(8));

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->KHXC_DB->clause_insert(array('table' => 'khxc_users',
                                                     'data'  => $insert));

          if (!($this->KHXC->IsError($sql))) {

               $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                            'table' => 'khxc_users'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Mail list subscribers have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Category();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Category                                          |
// +------------------------------------------------------------------+

function step_Category () {

// +--
// | Importer Function Step: 
// |
// | Online Store Category Import
// +--

$this->KHXC->globals('importer.step','7');
$this->KHXC->globals('importer.steptext','Online Store Category Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online store categories 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Store Category Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import online store categories from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online store categories from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'CategoryP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_CategoryP                                         |
// +------------------------------------------------------------------+

function step_CategoryP () {

// +--
// | Importer Function Step: 
// |
// | Online Store Category Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing online store categories. 
                 No categories have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Product();

} // End of if statement.

// +--
// | Define the destination application.
// +--

$app  = $this->KHXC->globals('khxc_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->KHXC->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('category',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'CategoryP';
$mtinfo['currtask']   = 'Online Store Category Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('category',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']           = array('source' => 'category_id', 'filter' => '', 'dvalue' => '');
     $translation['name']         = array('source' => 'category_name', 'filter' => '', 'dvalue' => '');
     $translation['keywords']     = array('source' => 'category_name', 'filter' => '', 'dvalue' => '');
     $translation['description']  = array('source' => 'category_desc', 'filter' => '', 'dvalue' => '');
     $translation['deschastags']  = array('source' => '', 'filter' => '', 'dvalue' => '0');
     $translation['skinoverride'] = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['catimg']       = array('source' => 'category_imgsm', 'filter' => '', 'dvalue' => '');
     $translation['splashdisp']   = array('source' => 'category_splashdisp', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['subdispnum']   = array('source' => 'category_catcount', 'filter' => '', 'dvalue' => '');
     $translation['subdisptype']  = array('source' => '', 'filter' => '', 'dvalue' => 'default');
     $translation['proddispnum']  = array('source' => 'category_smcount', 'filter' => '', 'dvalue' => '');
     $translation['proddisptype'] = array('source' => '', 'filter' => '', 'dvalue' => 'default');
     $translation['catmulti']     = array('source' => '', 'filter' => '', 'dvalue' => '0');
     $translation['xcat']         = array('source' => 'category_xcat', 'filter' => '', 'dvalue' => '');
     $translation['catview']      = array('source' => '', 'filter' => '', 'dvalue' => 'A');
     $translation['catviewg']     = array('source' => '', 'filter' => '', 'dvalue' => '');

     $sort_order = 0;

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if (!(empty($info['dvalue']))) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: PNG/GIF replacement for 'none.*'.
          // +--

          if ($row['category_imgsm'] == 'none.gif')    {$insert['catimg'] = 'none.png';}

          // +--
          // | SPECIAL: Handle tags in description.
          // +--

          $insert['description'] = $this->import_changetags($row['category_desc']);

          if (preg_match('/\<.*?\>/',$insert['description'])) {$insert['deschastags'] = '1';}

          // +--
          // | SPECIAL: Sort Order
          // +--

          $sort_order++;

          $insert['sortorder'] = $sort_order;

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->KHXC_DB->clause_insert(array('table' => $app . '_cat',
                                                     'data'  => $insert));

          if (!($this->KHXC->IsError($sql))) {

               $result = $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_cat'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online store categories have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Product();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Product                                           |
// +------------------------------------------------------------------+

function step_Product () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Import
// +--

$this->KHXC->globals('importer.step','8');
$this->KHXC->globals('importer.steptext','Online Store Product Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online store products 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Store Product Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import online store products from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online store products from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'ProductP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProductP                                          |
// +------------------------------------------------------------------+

function step_ProductP () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing online store products. 
                 No products have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_ProdOpt();

} // End of if statement.

// +--
// | Define the destination application.
// +--

$app  = $this->KHXC->globals('khxc_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->KHXC->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('product',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'ProductP';
$mtinfo['currtask']   = 'Online Store Product Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('product',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']             = array('source' => 'product_id', 'filter' => '', 'dvalue' => '');
     $translation['name']           = array('source' => 'product_name', 'filter' => '', 'dvalue' => '');
     $translation['prodnum']        = array('source' => 'product_number', 'filter' => '', 'dvalue' => '');
     $translation['pricestatus']    = array('source' => 'product_pricestatus', 'filter' => '', 'dvalue' => '');
     $translation['regprice']       = array('source' => 'product_regprice', 'filter' => '', 'dvalue' => '');
     $translation['saleprice']      = array('source' => 'product_saleprice', 'filter' => '', 'dvalue' => '');
     $translation['volprice']       = array('source' => 'product_volprice', 'filter' => '', 'dvalue' => '');
     $translation['voltext']        = array('source' => 'product_voltext', 'filter' => '', 'dvalue' => '');
     $translation['recurprice']     = array('source' => 'product_recurprice', 'filter' => '', 'dvalue' => '');
     $translation['whlprice']       = array('source' => 'product_regprice', 'filter' => '', 'dvalue' => '');
     $translation['affilcomm']      = array('source' => '', 'filter' => '', 'dvalue' => '0.00');
     $translation['keywords']       = array('source' => 'product_keywords', 'filter' => '', 'dvalue' => '');
     $translation['deschastags']    = array('source' => '', 'filter' => '', 'dvalue' => '0');
     $translation['skinoverride']   = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['lgdisp']         = array('source' => 'default', 'filter' => '', 'dvalue' => '');
     $translation['reldisptype']    = array('source' => 'default', 'filter' => '', 'dvalue' => '');
     $translation['reldispnum']     = array('source' => '', 'filter' => '', 'dvalue' => '1');
     $translation['prodmulti']      = array('source' => '', 'filter' => '', 'dvalue' => '0');
     $translation['imgsm']          = array('source' => 'product_imgsm', 'filter' => '', 'dvalue' => '');
     $translation['imglg']          = array('source' => 'product_imglg', 'filter' => '', 'dvalue' => '');
     $translation['imgxl']          = array('source' => 'product_imgxlg', 'filter' => '', 'dvalue' => '');
     $translation['splashdisp']     = array('source' => 'product_splashdisp', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['newdisp']        = array('source' => 'product_new', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['specialsdisp']   = array('source' => 'product_special', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['bestselldisp']   = array('source' => 'product_bestsell', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['featuredisp']    = array('source' => 'product_splashdisp', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['taxstateprov']   = array('source' => 'product_taxstateprov', 'filter' => 'yn2bool', 'dvalue' => '');
      // CCP51-UK Different Tax Settings.
     $translation['taxcountry']     = array('source' => 'product_taxcountry', 'filter' => 'taxcountry', 'dvalue' => '');
     $translation['useinv']         = array('source' => 'product_useinv', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['invlevel']       = array('source' => 'product_inv', 'filter' => '', 'dvalue' => '');
     $translation['addemtext']      = array('source' => 'product_addemtext', 'filter' => '', 'dvalue' => '');
     $translation['delmethod']      = array('source' => 'product_delmethod', 'filter' => '', 'dvalue' => '');
     $translation['customship']     = array('source' => 'product_customship', 'filter' => '', 'dvalue' => '');
     $translation['dlfile']         = array('source' => 'product_dlfile', 'filter' => '', 'dvalue' => '');
     $translation['shiponename']    = array('source' => 'product_shiponename', 'filter' => '', 'dvalue' => '');
     $translation['shiponeprice']   = array('source' => 'product_shiponeprice', 'filter' => '', 'dvalue' => '');
     $translation['shiptwoname']    = array('source' => 'product_shiptwoname', 'filter' => '', 'dvalue' => '');
     $translation['shiptwoprice']   = array('source' => 'product_shiptwoprice', 'filter' => '', 'dvalue' => '');
     $translation['shipthreename']  = array('source' => 'product_shipthreename', 'filter' => '', 'dvalue' => '');
     $translation['shipthreeprice'] = array('source' => 'product_shipthreeprice', 'filter' => '', 'dvalue' => '');
     $translation['shiplocal']      = array('source' => 'product_shiplocal', 'filter' => '', 'dvalue' => '');
     $translation['shipint']        = array('source' => 'product_shipint', 'filter' => '', 'dvalue' => '');
     $translation['shiplength']     = array('source' => 'product_shiplength', 'filter' => '', 'dvalue' => '');
     $translation['shipwidth']      = array('source' => 'product_shipwidth', 'filter' => '', 'dvalue' => '');
     $translation['shipheight']     = array('source' => 'product_shipheight', 'filter' => '', 'dvalue' => '');
     $translation['shipweight']     = array('source' => 'product_shipweight', 'filter' => '', 'dvalue' => '');
     $translation['shipnumbox']     = array('source' => 'product_shipnumbox', 'filter' => '', 'dvalue' => '');
     $translation['shipstateprov']  = array('source' => 'product_shipstateprov', 'filter' => '', 'dvalue' => '');
     $translation['shipcountry']    = array('source' => 'product_shipcountry', 'filter' => 'country', 'dvalue' => '');
     $translation['shipzip']        = array('source' => 'product_shipzip', 'filter' => '', 'dvalue' => '');
     $translation['shipemail']      = array('source' => 'product_shipemail', 'filter' => '', 'dvalue' => '');
     $translation['xcat']           = array('source' => 'product_xcat', 'filter' => '', 'dvalue' => '');
     $translation['xprod']          = array('source' => 'product_xprod', 'filter' => '', 'dvalue' => '');
     $translation['xprodoptions']   = array('source' => 'product_xopt', 'filter' => '', 'dvalue' => '');
     $translation['prodview']       = array('source' => '', 'filter' => '', 'dvalue' => 'A');
     $translation['prodviewg']      = array('source' => '', 'filter' => '', 'dvalue' => '');

     $sort_order = 0;

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if (!(empty($info['dvalue']))) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Strip tags from product name.
          // +--

          $insert['name'] = strip_tags($row['product_name']);

          // +--
          // | SPECIAL: PNG/GIF replacement for 'none.*'.
          // +--

          if ($row['product_imgsm'] == 'none.gif')    {$insert['imgsm'] = 'none.png';}
          if ($row['product_imglg'] == 'none.gif')    {$insert['imglg'] = 'none.png';}
          if ($row['product_imgxlg'] == 'none.gif')   {$insert['imgxl'] = 'none.png';}

          // +--
          // | SPECIAL: Sort Order
          // +--

          $sort_order++;

          $insert['sortorder'] = $sort_order;

          // +--
          // | SPECIAL: Handle tags in long description.
          // +--

          $insert['desclong'] = $this->import_changetags($row['product_desclong']);

          if (preg_match('/\<.*?\>/',$insert['desclong'])) {$insert['deschastags'] = '1';}

          // +--
          // | SPECIAL: Handle required fields.
          // +--

          if (empty($insert['saleprice']))      {$insert['saleprice']      = '0.00';}
          if (empty($insert['shiponeprice']))   {$insert['shiponeprice']   = '0.00';}
          if (empty($insert['shiptwoprice']))   {$insert['shiptwoprice']   = '0.00';}
          if (empty($insert['shipthreeprice'])) {$insert['shipthreeprice'] = '0.00';}
          if (empty($insert['customship']))     {$insert['customship']     = 'user';}
          if (empty($insert['lgdisp']))         {$insert['lgdisp']         = 'default';}
          if (empty($insert['reldisptype']))    {$insert['reldisptype']    = 'default';}
          if (empty($insert['reldispnum']))     {$insert['reldispnum']     = '1';}

          // +--
          // | SPECIAL: Strip tags in short description.
          // +--

          $insert['descshort'] = $this->import_changetags($row['product_descshort']);

          if (empty($insert['descshort'])) {$insert['descshort'] = $insert['desclong'];}

          $insert['descshort'] = strip_tags($insert['descshort']);

          // +--
          // | SPECIAL: UPSWEBAPI => UPSTOOLS
          // +--

          if ($insert['shiplocal'] == 'UPSWEBAPI') {$insert['shiplocal'] = 'UPSTOOLS';}
          if ($insert['shipint']   == 'UPSWEBAPI') {$insert['shipint']   = 'UPSTOOLS';}

          // +--
          // | SPECIAL: Index
          // +--

          $insert['prodidx'] = strtoupper(substr($insert['name'],0,1));

          if (preg_match('/^[\d]/',$insert['prodidx'])) {$insert['prodidx'] = 'A';}

          // +--
          // | SPECIAL: Sort Price
          // +--

          $insert['sortprice'] = intval($insert['regprice']); 

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->KHXC_DB->clause_insert(array('table' => $app . '_prod',
                                                     'data'  => $insert));

          if (!($this->KHXC->IsError($sql))) {

               $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_prod'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online store products have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_ProdOpt();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProdOpt                                           |
// +------------------------------------------------------------------+

function step_ProdOpt () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Option Import
// +--

$this->KHXC->globals('importer.step','9');
$this->KHXC->globals('importer.steptext','Online Store Product Option Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online store product options 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Store Product Option Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import online store product options from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online store product options from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'ProdOptP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_ProdOptP                                          |
// +------------------------------------------------------------------+

function step_ProdOptP () {

// +--
// | Importer Function Step: 
// |
// | Online Store Product Option Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing online store product options. 
                 No options have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_DynForm();

} // End of if statement.

// +--
// | Define the destination application.
// +--

$app  = $this->KHXC->globals('khxc_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->KHXC->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Get all of the product option selection items.
// +--

$optionsel = $this->import_load_data('optionsel',$tabledefs,0,'ALL');

if (($this->KHXC->IsError($optsel)) || (empty($optsel))) {$optsel = array();}

$fieldorder = 0;
$xsel       = array();

if (!(empty($optionsel))) {

     foreach ($optionsel as $num => $row) {

          $fieldorder++;

          $inventory = $row['optionsel_inv']; if (empty($inventory)) {$inventory = '0';}

          $pricechngreg = $row['optionsel_price']; if (empty($pricechngreg)) {$pricechngreg = '0.00';}

          if (($pricechngreg > 0) && ($row['optionsel_pricech'] == 'D')) {$pricechngreg = '-' . $pricechngreg;}
          elseif ($pricechngreg > 0)                                     {$pricechngreg = '+' . $pricechngreg;}

          $weightchng = $row['optionsel_weight']; if (empty($weightchng)) {$weightchng = '0.000';}

          if (($weightchng > 0) && ($row['optionsel_weightch'] == 'D')) {$weightchng = '-' . $weightchng;}
          elseif ($weightchng > 0)                                      {$weightchng = '+' . $weightchng;}       

          $xsel[$row['optionsel_option']][] = array('id'           => $row['optionsel_option'] . '-' . $row['optionsel_id'],
                                                    'name'         => $row['optionsel_selname'],
                                                    'pricechngreg' => $pricechngreg,
                                                    'pricechngrec' => '0.00',
                                                    'pricechngwhl' => $pricechngreg,
                                                    'afflcommchng' => '0.00',
                                                    'weightchng'   => $weightchng,
                                                    'inventory'    => $inventory,
                                                    'downloadfile' => '',
                                                    'fieldorder'   => $fieldorder);

     } // End of foreach statement.

} // End of foreach statement.

$optionsel = $xsel; unset($xsel);

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('optionprod',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'ProdOptP';
$mtinfo['currtask']   = 'Online Store Product Option Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('optionprod',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id'] = array('source' => 'optionprod_id', 'filter' => '', 'dvalue' => '');
     $translation['name'] = array('source' => 'optionprod_name', 'filter' => '', 'dvalue' => '');
     $translation['deschastags'] = array('source' => '', 'filter' => '', 'dvalue' => '0');
     $translation['required'] = array('source' => 'optionprod_required', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['useinventory'] = array('source' => 'optionprod_inv', 'filter' => 'yn2bool', 'dvalue' => '');

     $sort_order = 0;

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if (!(empty($info['dvalue']))) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Handle tags in description.
          // +--

          $insert['description'] = $this->import_changetags($row['optionprod_descript']);

          if (preg_match('/\<.*?\>/',$insert['description'])) {$insert['deschastags'] = '1';}

          // +--
          // | SPECIAL: Field Order
          // +--

          $sort_order++;

          $insert['fieldorder'] = $sort_order;

          // +--
          // | SPECIAL: Field Type
          // +--

          $field_type = 'TEXTBOX-REG';

          if     ($row['optionprod_display_type'] == 'TEXTBOX')     {$field_type = 'TEXTBOX-REG';}
          elseif ($row['optionprod_display_type'] == 'TEXTAREA')    {$field_type = 'TEXTAREA-SMALL';}
          elseif ($row['optionprod_display_type'] == 'RADIO')       {$field_type = 'RADIO-CUSTOM';}
          elseif ($row['optionprod_display_type'] == 'SELECT')      {$field_type = 'SELECT-CUSTOM';}
          elseif ($row['optionprod_display_type'] == 'SELECT-MULT') {$field_type = 'CHECKBOX-CUSTOM';}
          elseif ($row['optionprod_display_type'] == 'CHECKBOX')    {$field_type = 'CHECKBOX-CUSTOM';}

          $insert['fieldtype'] = $field_type;

          // +--
          // | SPECIAL: CSS Class
          // +--

          if (($field_type == 'RADIO-CUSTOM') || ($field_type == 'CHECKBOX-CUSTOM')) {

               $insert['cssclass'] = 'khxc_formfieldradcb';

          } else {

               $insert['cssclass'] = 'khxc_formfield';

          } // End of if statement.

          // +--
          // | SPECIAL: Option Selection Items - Build them out here.
          // +--

          $insert['xprodoptionsel'] = '';

          if (!(empty($optionsel[$insert['id']]))) {

               foreach ($optionsel[$insert['id']] as $xnum => $xrow) {

                    $insert['xprodoptionsel'] .= $xrow['id'] . ', ';

                    $sql = $this->KHXC_DB->clause_insert(array('table' => $app . '_prodoptionsel',
                                                               'data'  => $xrow));

                    if (!($this->KHXC->IsError($sql))) {

                         $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                                      'table' =>  $app . '_prodoptionsel'));

                    } // End of if statement.

               } // End of foreach statement.

               if (preg_match('/, $/',$insert['xprodoptionsel'])) {$insert['xprodoptionsel'] = rtrim($insert['xprodoptionsel'],', ');}

          } // End of if statement.

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->KHXC_DB->clause_insert(array('table' => $app . '_prodoptions',
                                                     'data'  => $insert));

          if (!($this->KHXC->IsError($sql))) {

               $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_prodoptions'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online store product options have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_DynForm();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DynForm                                           |
// +------------------------------------------------------------------+

function step_DynForm () {

// +--
// | Importer Function Step: 
// |
// | Dynamic Form Import
// +--

$this->KHXC->globals('importer.step','10');
$this->KHXC->globals('importer.steptext','Dynamic Form Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import dynamic forms 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Dynamic Form Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import Dynamic Forms from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the dynamic forms from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'DynFormP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DynFormP                                          |
// +------------------------------------------------------------------+

function step_DynFormP () {

// +--
// | Importer Function Step: 
// |
// | Dynamic Form Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing Dynamic Forms. 
                 No dynamic forms have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Orders();

} // End of if statement.

// +--
// | Define the destination application.
// +--

$app  = $this->KHXC->globals('khxc_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->KHXC->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Get all of the dynamic form selection items.
// +--

$dynformfieldsel = $this->import_load_data('dynformfieldsel',$tabledefs,0,'ALL');

if (($this->KHXC->IsError($dynformfieldsel)) || (empty($dynformfieldsel))) {$dynformfieldsel = array();}

$xsel = array();

if (!(empty($dynformfieldsel))) {

     foreach ($dynformfieldsel as $num => $row) {

          $xsel[$row['dynformfieldsel_field']][] = $row['dynformfieldsel_value'];

     } // End of foreach statement.

} // End of foreach statement.

$dynformfieldsel = $xsel; unset($xsel);

// +--
// | Get all of the dynamic form fields.
// +--

$dynformfield = $this->import_load_data('dynformfield',$tabledefs,0,'ALL');

if (($this->KHXC->IsError($dynformfield)) || (empty($dynformfield))) {$dynformfield = array();}

$xfield = array();

$fieldorder = 0;

if (!(empty($dynformfield))) {

     foreach ($dynformfield as $num => $row) {

          $fieldorder++;

          $xsel  = array();
          $max   = 20;
          $count = 0;

          while ($count < $max) {

               if (!(empty($dynformfieldsel[$row['dynformfield_id']][$count]))) {

                    $value = $dynformfieldsel[$row['dynformfield_id']][$count];

               } else {

                    $value = '';

               } // End of if statement.

               $xsel[$count + 1] = $value;

               $count++;

          } // End of while statement.

          $required = '0';
          if ($row['dynformfield_not_null'] == 'Y') {$required = '1';}

          $field_type = 'TEXTBOX-REG';
          if     ($row['dynformfield_display_type'] == 'TEXTBOX')     {$field_type = 'TEXTBOX-REG';}
          elseif ($row['dynformfield_display_type'] == 'TEXTAREA')    {$field_type = 'TEXTAREA-SMALL';}
          elseif ($row['dynformfield_display_type'] == 'RADIO')       {$field_type = 'RADIO-CUSTOM';}
          elseif ($row['dynformfield_display_type'] == 'SELECT')      {$field_type = 'SELECT-CUSTOM';}
          elseif ($row['dynformfield_display_type'] == 'SELECT-MULT') {$field_type = 'CHECKBOX-CUSTOM';}
          elseif ($row['dynformfield_display_type'] == 'CHECKBOX')    {$field_type = 'CHECKBOX-CUSTOM';}

          if (($field_type == 'RADIO-CUSTOM') || ($field_type == 'CHECKBOX-CUSTOM')) {

               $cssclass = 'khxc_formfieldradcb';

          } else {

               $cssclass = 'khxc_formfield';

          } // End of if statement.

          $xfield[$row['dynformfield_form']][] = array('id'           => $row['dynformfield_id'],
                                                       'formid'       => $row['dynformfield_form'],
                                                       'name'         => $row['dynformfield_dispname'],
                                                       'section'      => 'Form',
                                                       'defaultvalue' => '',
                                                       'isemailfield' => '0',
                                                       'description'  => '',
                                                       'deschastags'  => '0',
                                                       'required'     => $required,
                                                       'type'         => $field_type,
                                                       'cssclass'     => $cssclass,
                                                       'fieldorder'   => $fieldorder,
                                                       'list_1'       => $xsel[1],
                                                       'list_2'       => $xsel[2],
                                                       'list_3'       => $xsel[3],
                                                       'list_4'       => $xsel[4],
                                                       'list_5'       => $xsel[5],
                                                       'list_6'       => $xsel[6],
                                                       'list_7'       => $xsel[7],
                                                       'list_8'       => $xsel[8],
                                                       'list_9'       => $xsel[9],
                                                       'list_10'      => $xsel[10],
                                                       'list_11'      => $xsel[11],
                                                       'list_12'      => $xsel[12],
                                                       'list_13'      => $xsel[13],
                                                       'list_14'      => $xsel[14],
                                                       'list_15'      => $xsel[15],
                                                       'list_16'      => $xsel[16],
                                                       'list_17'      => $xsel[17],
                                                       'list_18'      => $xsel[18],
                                                       'list_19'      => $xsel[19],
                                                       'list_20'      => $xsel[20]);

     } // End of foreach statement.

} // End of foreach statement.

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('dynform',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'DynFormP';
$mtinfo['currtask']   = 'Dynamic Form Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('dynform',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']           = array('source' => 'dynform_id', 'filter' => '', 'dvalue' => '');
     $translation['name']         = array('source' => 'dynform_name', 'filter' => '', 'dvalue' => '');
     $translation['subject']      = array('source' => 'dynform_name', 'filter' => '', 'dvalue' => '0');
     $translation['usexhtml']     = array('source' => '', 'filter' => '', 'dvalue' => '0');
     $translation['xhtmlskin']    = array('source' => '', 'filter' => '', 'dvalue' => 'skin.Mail');
     $translation['defaultfrom']  = array('source' => 'dynform_email', 'filter' => '', 'dvalue' => '');
     $translation['defaultto']    = array('source' => 'dynform_email', 'filter' => '', 'dvalue' => '');
     $translation['defaultcc']    = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['defaultbcc']   = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['deschastags']  = array('source' => '', 'filter' => '', 'dvalue' => '0');
     $translation['skinoverride'] = array('source' => '', 'filter' => '', 'dvalue' => '');

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if (!(empty($info['dvalue']))) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Description
          // +--

          $insert['description'] = '';

          $result = $this->KHXC_File->read($this->KHXC->globals('khxc_cgi.import_dirdata') . '/elements/' . $insert['id'] . '.txt');

          if (!($this->KHXC->IsError($result))) {$insert['description'] = $result;}

          $insert['description'] = $this->import_changetags($insert['description']);

          if (preg_match('/\<.*?\>/',$insert['description'])) {$insert['deschastags'] = '1';}

          // +--
          // | SPECIAL: Message Head
          // +--

          $insert['msghead'] = 'The following information was just submitted via the \'' . $insert['name'] . '\' form.';

          // +--
          // | SPECIAL: Form Fields - Build them out here.
          // +--

          if (!(empty($xfield[$insert['id']]))) {

               foreach ($xfield[$insert['id']] as $xnum => $xrow) {

                    $sql = $this->KHXC_DB->clause_insert(array('table' => $app . '_dynformfields',
                                                               'data'  => $xrow));

                    if (!($this->KHXC->IsError($sql))) {

                         $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                                      'table' => $app . '_dynformfields'));

                    } // End of if statement.

               } // End of foreach statement.

          } // End of if statement.

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->KHXC_DB->clause_insert(array('table' => $app . '_dynforms',
                                                     'data'  => $insert));

          if (!($this->KHXC->IsError($sql))) {

               $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_dynforms'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Dynamic forms have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Orders();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Orders                                            |
// +------------------------------------------------------------------+

function step_Orders () {

// +--
// | Importer Function Step: 
// |
// | Online Orders Import
// +--

$this->KHXC->globals('importer.step','11');
$this->KHXC->globals('importer.steptext','Online Orders Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online orders 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Orders Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import Online Orders from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online orders from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'OrdersP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_OrdersP                                           |
// +------------------------------------------------------------------+

function step_OrdersP () {

// +--
// | Importer Function Step: 
// |
// | Online Orders Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing Online Orders. 
                 No online orders have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_OrderItems();

} // End of if statement.

// +--
// | Define the destination application.
// +--

$app  = $this->KHXC->globals('khxc_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->KHXC->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('tracking',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'OrdersP';
$mtinfo['currtask']   = 'Online Orders Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('tracking',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']            = array('source' => 'tracking_id', 'filter' => '', 'dvalue' => '');
     $translation['sessionid']     = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['status']        = array('source' => 'tracking_status', 'filter' => '', 'dvalue' => '');
     $translation['ordertotal']    = array('source' => 'tracking_total', 'filter' => 'priceround', 'dvalue' => '');
     $translation['recurtotal']    = array('source' => 'tracking_recurtotal', 'filter' => 'priceround', 'dvalue' => '');
     // CCP51-UK Vat Settings.
     $translation['recurtotaleutax']    = array('source' => 'tracking_recurvat', 'filter' => 'priceround', 'dvalue' => '');
     $translation['recurtotaleutaxrefund']    = array('source' => 'tracking_recurvatrefund', 'filter' => 'priceround', 'dvalue' => '');
     $translation['taxsptotal']    = array('source' => 'tracking_stateprovtax', 'filter' => 'priceround', 'dvalue' => '');
     $translation['taxctotal']     = array('source' => 'tracking_countrytax', 'filter' => 'priceround', 'dvalue' => '');
     // CCP51-UK Vat Settings.
     $translation['eutaxrefundtotal']     = array('source' => 'tracking_vatrefund', 'filter' => 'priceround', 'dvalue' => '');
     $translation['custsaletotal'] = array('source' => 'tracking_saletotal', 'filter' => 'priceround', 'dvalue' => '');
     $translation['disctotal']     = array('source' => 'tracking_discounttotal', 'filter' => 'priceround', 'dvalue' => '');
     $translation['shiptotal']     = array('source' => 'tracking_shippingtotal', 'filter' => 'priceround', 'dvalue' => '');
     $translation['commtotal']     = array('source' => '', 'filter' => 'priceround', 'dvalue' => '0.00');
     $translation['disccode']      = array('source' => 'tracking_discountcode', 'filter' => '', 'dvalue' => '');
     $translation['taxexemptnum']  = array('source' => 'tracking_othertax', 'filter' => '', 'dvalue' => '');
     $translation['custsaledesc']  = array('source' => 'tracking_saledesc', 'filter' => '', 'dvalue' => '');
     $translation['fname']         = array('source' => 'tracking_firstname', 'filter' => '', 'dvalue' => '');
     $translation['lname']         = array('source' => 'tracking_lastname', 'filter' => '', 'dvalue' => '');
     $translation['phone']         = array('source' => 'tracking_phone', 'filter' => '', 'dvalue' => '');
     $translation['fax']           = array('source' => 'tracking_fax', 'filter' => '', 'dvalue' => '');
     $translation['email']         = array('source' => 'tracking_email', 'filter' => 'strtolower', 'dvalue' => '');
     $translation['company']       = array('source' => 'tracking_company', 'filter' => '', 'dvalue' => '');
     $translation['addone']        = array('source' => 'tracking_addressone', 'filter' => '', 'dvalue' => '');
     $translation['addtwo']        = array('source' => 'tracking_addresstwo', 'filter' => '', 'dvalue' => '');
     $translation['city']          = array('source' => 'tracking_city', 'filter' => '', 'dvalue' => '');
     $translation['stateprov']     = array('source' => 'tracking_stateprov', 'filter' => '', 'dvalue' => '');
     $translation['country']       = array('source' => 'tracking_country', 'filter' => 'country', 'dvalue' => '');
     $translation['postalcode']    = array('source' => 'tracking_zip', 'filter' => '', 'dvalue' => '');
     $translation['rescom']        = array('source' => 'tracking_rescom', 'filter' => '', 'dvalue' => '');
     $translation['customone']     = array('source' => 'tracking_customone', 'filter' => '', 'dvalue' => '');
     $translation['customtwo']     = array('source' => 'tracking_customtwo', 'filter' => '', 'dvalue' => '');
     $translation['customthree']   = array('source' => 'tracking_customthree', 'filter' => '', 'dvalue' => '');
     $translation['customfour']    = array('source' => 'tracking_customfour', 'filter' => '', 'dvalue' => '');
     $translation['customfive']    = array('source' => 'tracking_customfive', 'filter' => '', 'dvalue' => '');
     $translation['customsix']     = array('source' => 'tracking_customsix', 'filter' => '', 'dvalue' => '');
     $translation['customseven']   = array('source' => 'tracking_customseven', 'filter' => '', 'dvalue' => '');
     $translation['customeight']   = array('source' => 'tracking_customeight', 'filter' => '', 'dvalue' => '');
     $translation['customnine']    = array('source' => 'tracking_customnine', 'filter' => '', 'dvalue' => '');
     $translation['customten']     = array('source' => 'tracking_customten', 'filter' => '', 'dvalue' => '');
     $translation['postordaff']    = array('source' => 'tracking_updateaff', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['postordinv']    = array('source' => 'tracking_updateinv', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['postorddisc']   = array('source' => 'tracking_updatedisc', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['postordqb']     = array('source' => 'tracking_accexp', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['postordpt']     = array('source' => 'tracking_accexp', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['commentsint']   = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['commentsext']   = array('source' => 'tracking_comments', 'filter' => '', 'dvalue' => '');
     $translation['ipaddress']     = array('source' => 'tracking_ipadd', 'filter' => '', 'dvalue' => '');
     // CCP51-UK Vat and Netabnx Settings.
     $translation['netbanxref']     = array('source' => 'tracking_netbanxref', 'filter' => '', 'dvalue' => '');
     $translation['eutaxno']     = array('source' => 'tracking_othertax', 'filter' => '', 'dvalue' => '');

     $now  = $this->KHXC->globals('khxc_datetime.epoch');

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if (!(empty($info['dvalue']))) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Create the subtotal.
          // +--

          $subtotal = $insert['ordertotal'] - $insert['taxsptotal'] - $insert['taxctotal'] + $insert['custsaletotal'] + $insert['disctotal'] - $insert['shiptotal'];

          $insert['subtotal'] = $this->import_price_round($subtotal);

          // +--
          // | SPECIAL: Date Fields. EU Date
          // +--

          $insert['datemonth'] = preg_replace('/^(.*?)\/(.*?)\/(.*?)$/','\\2',$row['tracking_date']);
          $insert['dateday']   = preg_replace('/^(.*?)\/(.*?)\/(.*?)$/','\\1',$row['tracking_date']);
          $insert['dateyear']  = preg_replace('/^(.*?)\/(.*?)\/(.*?)$/','\\3',$row['tracking_date']);

          // +--
          // | SPECIAL: Epoch.
          // +--

          $insert['epochorder'] = $now;

          // +--
          // | SPECIAL: Payment Method
          // +--

          $insert['paymethod'] = preg_replace('/^ste\_gw\_/','',$row['tracking_paymethod']);

          // +--
          // | SPECIAL: Referer.
          // +--

          $insert['referrer'] = $row['tracking_refurl'];

          if (!(empty($row['tracking_affiliate']))) {$insert['referrer'] = $row['tracking_affiliate'];}

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->KHXC_DB->clause_insert(array('table' => $app . '_orders',
                                                     'data'  => $insert));

          if (!($this->KHXC->IsError($sql))) {

               $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_orders'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online orders have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_OrderItems();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_OrderItems                                        |
// +------------------------------------------------------------------+

function step_OrderItems () {

// +--
// | Importer Function Step: 
// |
// | Online Order Items Import
// +--

$this->KHXC->globals('importer.step','12');
$this->KHXC->globals('importer.steptext','Online Order Items Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import online order items 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Online Order Items Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import Online Order Items from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the online order items from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'OrderItemsP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_OrderItemsP                                       |
// +------------------------------------------------------------------+

function step_OrderItemsP () {

// +--
// | Importer Function Step: 
// |
// | Online Order Items Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing Online Order Items. 
                 No online order items have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Discounts();

} // End of if statement.

// +--
// | Define the destination application.
// +--

$app  = $this->KHXC->globals('khxc_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->KHXC->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('trackitem',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'OrderItemsP';
$mtinfo['currtask']   = 'Online Order Items Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('trackitem',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['orderid']    = array('source' => 'trackitem_tracknum', 'filter' => '', 'dvalue' => '');
     $translation['shipstatus'] = array('source' => 'trackitem_shipstatus', 'filter' => '', 'dvalue' => '');
     $translation['shipmethod'] = array('source' => 'trackitem_shipmethod', 'filter' => '', 'dvalue' => '');
     $translation['itemname']   = array('source' => 'trackitem_itemname', 'filter' => '', 'dvalue' => '');
     $translation['itemnum']    = array('source' => 'trackitem_itemnumber', 'filter' => '', 'dvalue' => '');
     $translation['itemid']     = array('source' => 'trackitem_cartprodid', 'filter' => '', 'dvalue' => '');
     $translation['itemquan']   = array('source' => 'trackitem_quantity', 'filter' => '', 'dvalue' => '');
     $translation['itemopts']   = array('source' => 'trackitem_options', 'filter' => '', 'dvalue' => '');
     $translation['ordertotal'] = array('source' => 'trackitem_prodtotal', 'filter' => 'priceround', 'dvalue' => '');
     $translation['recurtotal'] = array('source' => 'trackitem_recur', 'filter' => 'priceround', 'dvalue' => '');
     $translation['fname']      = array('source' => 'trackitem_shipfirstname', 'filter' => '', 'dvalue' => '');
     $translation['lname']      = array('source' => 'trackitem_shiplastname', 'filter' => '', 'dvalue' => '');
     $translation['company']    = array('source' => 'trackitem_shipcompany', 'filter' => '', 'dvalue' => '');
     $translation['addone']     = array('source' => 'trackitem_shipaddressone', 'filter' => '', 'dvalue' => '');
     $translation['addtwo']     = array('source' => 'trackitem_shipaddresstwo', 'filter' => '', 'dvalue' => '');
     $translation['city']       = array('source' => 'trackitem_shipcity', 'filter' => '', 'dvalue' => '');
     $translation['stateprov']  = array('source' => 'trackitem_shipstateprov', 'filter' => '', 'dvalue' => '');
     $translation['country']    = array('source' => 'trackitem_shipcountry', 'filter' => 'country', 'dvalue' => '');
     $translation['postalcode'] = array('source' => 'trackitem_shipzip', 'filter' => '', 'dvalue' => '');
     $translation['rescom']     = array('source' => 'trackitem_shiprescom', 'filter' => '', 'dvalue' => '');

     $now  = $this->KHXC->globals('khxc_datetime.epoch');

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if (!(empty($info['dvalue']))) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Create the ID.
          // +--

          $insert['id'] = $insert['orderid'] . '-' . $row['trackitem_id'];

          // +--
          // | SPECIAL: Epoch.
          // +--

          $insert['epochorder'] = $now;

          // +--
          // | SPECIAL: Cart Data.
          // +--

          $insert['cartdata'] = serialize(array());

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->KHXC_DB->clause_insert(array('table' => $app . '_orderitems',
                                                     'data'  => $insert));

          if (!($this->KHXC->IsError($sql))) {

               $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_orderitems'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Online order items have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Discounts();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Discounts                                         |
// +------------------------------------------------------------------+

function step_Discounts () {

// +--
// | Importer Function Step: 
// |
// | Discount Code Import
// +--

$this->KHXC->globals('importer.step','13');
$this->KHXC->globals('importer.steptext','Discount Code Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import discount codes 
from your {$software} installation.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'Discount Code Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import Discount Codes from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the discount codes from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'DiscountsP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_DiscountsP                                        |
// +------------------------------------------------------------------+

function step_DiscountsP () {

// +--
// | Importer Function Step: 
// |
// | Discount Code Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing Discount Codes. 
                 No discount codes have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_HtmlPage();

} // End of if statement.

// +--
// | Define the destination application.
// +--

$app  = $this->KHXC->globals('khxc_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->KHXC->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('discount',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'DiscountsP';
$mtinfo['currtask']   = 'Discount Code Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('discount',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']        = array('source' => 'discount_id', 'filter' => '', 'dvalue' => '');
     $translation['prodlimit'] = array('source' => 'discount_limitprod', 'filter' => '', 'dvalue' => '');
     $translation['xprod']     = array('source' => 'discount_xprod', 'filter' => '', 'dvalue' => '');
     $translation['active']    = array('source' => 'discount_active', 'filter' => 'yn2bool', 'dvalue' => '');

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if (!(empty($info['dvalue']))) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: Code Type
          // +--

          $insert['codetype'] = 1;

          if ($row['discount_type'] == '5') {$insert['codetype'] = 5;}

          // +--
          // | SPECIAL: Code Value
          // +--

          $insert['codevalue'] = $this->import_price_round($row['discount_value']);

          if ($row['discount_currpct'] == 'PCT') {$insert['codevalue'] .= '0%';}

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->KHXC_DB->clause_insert(array('table' => $app . '_discounts',
                                                     'data'  => $insert));

          if (!($this->KHXC->IsError($sql))) {

               $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_discounts'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. Discount codes have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_HtmlPage();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_HtmlPage                                          |
// +------------------------------------------------------------------+

function step_HtmlPage () {

// +--
// | Importer Function Step: 
// |
// | HTML Page Import
// +--

$this->KHXC->globals('importer.step','14');
$this->KHXC->globals('importer.steptext','HTML Page Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import HTML pages 
from your {$software} installation.  HTML pages imported are of the 
user-defined type.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'HTML Page Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import HTML Pages from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the HTML pages from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'HtmlPageP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_HtmlPageP                                         |
// +------------------------------------------------------------------+

function step_HtmlPageP () {

// +--
// | Importer Function Step: 
// |
// | HTML Page Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing HTML Pages. 
                 No HTML pages have been imported.  You can now continue through 
                 the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Skin();

} // End of if statement.

// +--
// | Define the destination application.
// +--

$app  = $this->KHXC->globals('khxc_cgi.import_destapp');

// +--
// | Load settings and table definitions.
// +--

$settings = $this->import_load_settings('settings.csv');

if ($this->KHXC->IsError($settings)) {return $settings;}

$tabledefs = $this->import_load_tabledefs($settings);

if ($this->KHXC->IsError($tabledefs)) {return $tabledefs;}

// +--
// | Handle multi-step operations.
// +--

$offset      = $this->KHXC->globals('khxc_cgi.offset'); if (empty($offset)) {$offset = 0;}
$count       = $this->dbrows_atonce;
$rowcount    = $this->import_count_rows('htmlpage',$tabledefs);
$endnum_calc = $offset + $this->dbrows_atonce;

if ($rowcount <= $endnum_calc) {$completed = 1;} else {$completed = 0;}

$new_offset  = $offset + $this->dbrows_atonce;
$ntaskcount  = ceil($rowcount / $this->dbrows_atonce);

if ($offset == 0)     {$ntaskcurr = 1;
} elseif ($completed) {$ntaskcurr = $ntaskcount;
} else                {$ntaskcurr = ceil($new_offset / $this->dbrows_atonce);}

$mtinfo = array();

$mtinfo['currstep']   = 'HtmlPageP';
$mtinfo['currtask']   = 'HTML Page Import';

$mtinfo['offset']     = $new_offset;
$mtinfo['ntaskcount'] = $ntaskcount;
$mtinfo['ntaskcurr']  = $ntaskcurr;
$mtinfo['mtcomplete'] = $completed;

$cgimtcomplete = $this->KHXC->globals('khxc_cgi.mtcomplete');

// +--
// | Load data.
// +--

$data = $this->import_load_data('htmlpage',$tabledefs,$offset,$count);

if ((!(empty($data))) && ($rowcount > 0) && (empty($cgimtcomplete))) {

     $translation = array();

     $translation['id']           = array('source' => 'htmlpage_id', 'filter' => '', 'dvalue' => '');
     $translation['dispname']     = array('source' => 'htmlpage_name', 'filter' => '', 'dvalue' => '');
     $translation['menudisp']     = array('source' => '', 'filter' => '', 'dvalue' => '1');
     $translation['titledisp']    = array('source' => 'htmlpage_usetitleimg', 'filter' => 'yn2bool', 'dvalue' => '');
     $translation['skinoverride'] = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['metatitle']    = array('source' => 'htmlpage_name', 'filter' => '', 'dvalue' => '');
     $translation['metakeywords'] = array('source' => '', 'filter' => '', 'dvalue' => '');
     $translation['metadesc']     = array('source' => '', 'filter' => '', 'dvalue' => '');

     $menu_order = 0;

     foreach ($data as $num => $row) {

          $insert = array();

          // +--
          // | STANDARD: Translated data
          // +--

          foreach ($translation as $key => $info) {

               $insert[$key] = $row[$info['source']];

               if (!(empty($info['dvalue']))) {$insert[$key] = $info['dvalue'];}
               if (!(empty($info['filter']))) {$insert[$key] = $this->import_filter($info['filter'],$insert[$key],$settings);}

               $insert[$key] = "{$insert[$key]}";

          } // End of foreach statement.

          // +--
          // | SPECIAL: HTML Content
          // +--

          $insert['htmlcontent'] = '';

          $result = $this->KHXC_File->read($this->KHXC->globals('khxc_cgi.import_dirdata') . '/elements/' . $insert['id'] . '.txt');

          if (!($this->KHXC->IsError($result))) {$insert['htmlcontent'] = $result;}

          $insert['htmlcontent'] = $this->import_changetags($insert['htmlcontent']);

          // +--
          // | SPECIAL: Menu Order
          // +--

          $menu_order++;

          $insert['menuorder'] = $menu_order;

          // +--
          // | Do the insert and don't worry about errors.  By doing an insert
          // | we don't overwrite any existing data.
          // +--

          $sql = $this->KHXC_DB->clause_insert(array('table' => $app . '_html',
                                                     'data'  => $insert));

          if (!($this->KHXC->IsError($sql))) {

               $this->KHXC_DB->sql_do(array('sql'   => $sql,
                                            'table' =>  $app . '_html'));

          } // End of if statement.

     } // End of foreach statement.

     // +--
     // | Present the multitask form.
     // +--

     return $this->do_multitask($mtinfo);

// +--
// | We're finished otherwise.
// +--

} else {

     $message = "Thank you. HTML pages have been imported.  You can now continue 
                 through the import process.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Skin();

} // End of if statement.

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Skin                                              |
// +------------------------------------------------------------------+

function step_Skin () {

// +--
// | Importer Function Step: 
// |
// | HTML Site Layout (Skin) Import
// +--

$this->KHXC->globals('importer.step','15');
$this->KHXC->globals('importer.steptext','HTML Site Layout (Skin) Import');

// +--
// | Print the form.
// +--

$this->KHXC->globals('khxc_cgi.import_do','0');

$software = $this->KHXC->globals('importer.name');

$header = <<<ENDOFTEXT

<p>Indicate below whether you would like to import your HTML site layout 
(skin) from your {$software} installation.  Your HTML site layout will be 
created as a new skin which you will need to assign to the application you 
are importing data into.  This assignment is not automatically done.</p>

<p><strong>Please Note</strong>: This HTML site layout to skin conversion is 
to be considered experimental and may or may not produce desired results and 
almost certainly will not product standards compliant output due to the fact 
that the KHXC is written in PHP using XHTML Strict displays with CSS 
and {$software} is written in Perl using non-standards compliant HTML.</p>

ENDOFTEXT;

$fields[0]['id']       = 'import_do';
$fields[0]['name']     = 'HTML Site Layout (Skin) Import';
$fields[0]['type']     = 'RADIO';
$fields[0]['required'] = '1';
$fields[0]['values']   = array('0' => 'Skip this step.',
                               '1' => 'Import the HTML Site Layout from ' . $software . '.');

$fields[0]['desc']     = <<<ENDOFTEXT

<p>Indcate whether you would like to import the HTML site layout from your 
{$software} installation.  You have the option to skip this step.</p>

ENDOFTEXT;

// +--
// | Print the form.
// +--

$this->disp_form(array('header' => $header,
                       'fields' => $fields,
                       'step'   => 'SkinP'));

// +--
// | Return true
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_SkinP                                             |
// +------------------------------------------------------------------+

function step_SkinP () {

// +--
// | Importer Function Step: 
// |
// | HTML Site Layout (Skin) Import - Process
// +--

// +--
// | Make sure all required fields were completed.
// +--

$fd = $this->formdata_array(array('import_destapp'     => 1,
                                  'import_dirdata'     => 1,
                                  'import_dirmedia'    => 1,
                                  'import_do'          => 0));

if ($this->KHXC->IsError($fd)) {return $fd;}

// +--
// | Go to the next step and print a confirm message if we're skipping
// | this step.
// +--

if (empty($fd['import_do'])) {

     $message = "Thank you. You selected to skip importing the HTML site layout. 
                 A new skin has not been created.";

     $this->disp_message($message,'CONFIRM');

     return $this->step_Final();

} // End of if statement.

// +--
// | Delete any skin named 'CCP5XIMPORT'.
// +--

$dest = $this->KHXC->globals('khxc.path_public') . '/skins/CCP5XIMPORT';

$this->KHXC_File->delete_dir($dest);

// +--
// | Copy the Ecom skin over to 'CCP5XIMPORT'.
// +--

$source = $this->KHXC->globals('khxc.path_public') . '/skins/Ecom';

$this->KHXC_File->copy_dir(array('source'     => $source,
                                 'dest'       => $dest,
                                 'replace'    => array('/Ecom/' => '/CCP5XIMPORT/'),
                                 'skip_dirs'  => array(0 => 'install'),
                                 'skip_files' => array()));

// +--
// | Get the HTML Site Layout content.
// +--

$content = $this->KHXC_File->read($this->KHXC->globals('khxc_cgi.import_dirdata') . '/elements/ste_layout.txt');

if (!(empty($content))) {

     // +--
     // | Strip everything before the open body tag (whether it's a CGI
     // | or regular tag - including the open body tag.
     // +--

     $content = preg_replace('/^(.*?)\<body(.*?)\>/is','',$content);
     $content = preg_replace('/^(.*?)\<body\>/is','',$content);
     $content = preg_replace('/^(.*?)\(CGIGET TYPE="SUB" VALUE="ste_exec_bodytag"\)/is','',$content);

     // +--
     // | Strip everything after the end body tag - including the 
     // | end body tag.
     // +--

     $content = preg_replace('/\<\/body\>(.*?)$/is','',$content);

     // +--
     // | Remove HTML Comments.
     // +--

     $content = preg_replace('/\<\!\-\-(.*?)\-\-\>/is','',$content);

     // +--
     // | Handle the title tag.
     // +--

     $content = preg_replace('/\(CGIGET TYPE="SUB" VALUE="ste_exec_pgtitle"\)/is','<?php $skinfunc->titletag($disp_title); ?>',$content);

     // +--
     // | Handle the content section.
     // +--

     $content = preg_replace('/\(CGIGET TYPE="SUB" VALUE="ste_exec_element" PARAMS="\(CGIVAR\)element_id\(\/CGIVAR\)"\)/is','<?php $skinfunc->content(); ?>',$content);

     // +--
     // | Do Menu Replacement.
     // +--

     $content = preg_replace('/\(CGIGET TYPE="SUB" VALUE="ste_cat_list"\)/is','<?php $skinfunc->namespace($app_id,\'femenus\',\'LEFT\'); $skinfunc->namespace($app_id,\'femenus\',\'RIGHT\'); ?>',$content);

     // +--
     // | Strip/Fix tags.
     // +--

     $content = $this->import_changetags($content);

     // +--
     // | Get our new skin.php template.
     // +--

     $xcontent = $this->import_return_skinphp();

     // +--
     // | Modify our template.
     // +--

     $xcontent = preg_replace('/\<khxc\:content \/\>/',$content,$xcontent);

     // +--
     // | Write our the modified skin.php.
     // +--

     $this->KHXC_File->write(array('name' => $dest . '/skin.php',
                                   'data' => $xcontent));

     // +--
     // | Replace the all.css file.
     // +--

     $content = $this->import_return_allcss();

     $this->KHXC_File->write(array('name' => $dest . '/css/all.css',
                                   'data' => $content));
     // +--
     // | Update the modules table.
     // +--

     $data = array('id'          => 'skin.CCP5XIMPORT',
                   'name'        => 'Imported CCP 5.x Skin',
                   'class'       => '',
                   'version'     => '1.0.0',
                   'app'         => '',
                   'type'        => 'SKIN',
                   'doc'         => '',
                   'description' => 'This skin was created during a data import.');

      $insert_clause = $this->KHXC_DB->clause_insert(array('table' => 'khxc_modules',
                                                                'data'  => $data));

      if (!($this->KHXC->IsError($insert_clause))) {

           $this->KHXC_DB->sql_do(array('sql'   => $insert_clause,
                                        'table' => 'khxc_modules'));

      } // End of if statement.

} // End of if statement.

// +--
// | Print a confirmation message.
// +--

$message = "Thank you. A new skin has been created based on your HTML site layout.  This 
            skin can be associated with an application in the KHXC management 
            interface using the Application Profile function in the Application: Profile 
            and Namespaces menu.";

$this->disp_message($message,'CONFIRM');

// +--
// | Go to the next step.
// +--

return $this->step_Final();

} // End of function.

// +------------------------------------------------------------------+
// | Function: step_Final                                             |
// +------------------------------------------------------------------+

function step_Final () {

// +--
// | Importer Function Step.
// +--

// +--
// | Define variables for the confirm display.
// +--

$link     = $this->KHXC->globals('khxc.script_backend');

// +--
// | Final Confirm Display
// +--

print <<<ENDOFTEXT

<p>The data import process has completed.  The data you chose to import 
has been saved to the Kryptronic Hybrid X Core (KHXC) database and the 
filesystem used by the KHXC.</p>

<p><a href="{$link}" title="Management Interface">Click here to run 
the KHXC Management Interface.</a></p>

ENDOFTEXT;

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Display                                                 |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: disp                                                   |
// +------------------------------------------------------------------+

function disp () {

// +--
// | This function displays the importer screen output.
// +--

// +--
// | Define our date for our copyright and our EOL.
// +--

$date_year = @date('Y');
$eol       = $this->KHXC->globals('khxc.eol');

$title_add = '';

if ($this->KHXC->globals('importer.steptext')) {

     $title_add = ' - ' . $this->KHXC->xhtml_translate($this->KHXC->globals('importer.steptext'),'ENCODE');

} // End of if statement.

// +--
// | Print the header section.
// +--

print <<<ENDOFTEXT

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>

<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /> 

<style type="text/css" media="all">

body {
     font-family: Verdana, Tahoma, Arial, sans-serif;
     font-size: 11px;
     color: #333333;
     font-weight: normal;
     text-align: left;
     background-color: #F5F5F5;
     margin: 20px;
     }

a {
     color: #30569D;
     text-decoration: none;
     font-weight: normal;
     }

a.alt {
     color: #FFFFFF;
     font-weight: normal;
     }

a:hover {
     text-decoration: underline;
     }

p.inline {
     display: inline;
     }

.strong {
     font-weight: bold;
     }

#header {
     background-color: #FFFFFF;
     width: 610px;
     border: 1px solid #333333;
     padding: 5px;
     margin: 10px auto 0px auto;
     }

#content {
     color: #333333;
     background-color: #FFFFFF;
     border-left: 1px solid #333333;
     border-right: 1px solid #333333;
     border-bottom: 1px solid #333333;
     width: 600px;
     padding: 10px;
     margin: auto;
     }

#footer {
     color: #FFFFFF;
     background-color: #3872B2;
     border: 1px solid #333333;
     width: 600px;
     padding: 10px;
     margin: 10px auto 10px auto;
     }

#pgtitle {
     color: #FF6600;
     padding: 0px;
     margin: 0px 0px 10px 0px;
     font-weight: bold;
     font-size: 18px;
     }

#meter {
     width: auto;
     margin: auto;
     text-align: center;
     }

p.meter {
     color: #FFFFFF;
     background-color: #3872B2;
     display: inline;
     font-weight: bold;
     padding: 3px;
     }

p.metercomp {
     color: #FFFFFF;
     background-color: #3872B2;
     display: inline;
     font-weight: bold;
     padding: 3px;
     }

p.meterpend {
     color: #30569D;
     background-color: #3872B2;
     display: inline;
     font-weight: bold;
     padding: 3px;
     }

.msgerror {
     color: #FF0000;
     font-weight: bold;
     }

.msgconf {
     color: #339933;
     font-weight: bold;
     }

.hidden {
     display: none;
     }

.khxc_formfield {
     background-color: #FFFFFF;
     border: 1px solid #8C867B;
     margin: 5px 5px 0px 2px;
     font-size: 11px;
     }

.khxc_formfield:hover {
     background-color: #F5F5F5;
     }

.formbutton {
     color: #FFFFFF;
     background-color: #FF6600;
     border: 1px solid #333333;
     padding: 1px;
     margin-top: 10px;
     margin-left: 2px;
     font-weight: bold;
     width: 100px;
     font-size: 11px;
     }

.formbutton:hover {
     color: #333333;
     background-color: #EFEFEF;
     }

fieldset {
     border: 1px solid #8C867B;
     padding: 10px;
     margin-bottom: 10px;
     }

</style>

<title>Kryptronic Hybrid X Core (KHXC): Data Importer{$title_add}</title>

<script type="text/javascript">
<!--

var submitted = false;
function DisableSubmit(formname) {
if(submitted == true) { return; }
document.forms[formname].submit();
document.forms[formname].SUBMIT.value = 'Please Wait...';
document.forms[formname].SUBMIT.disabled = true;
submitted = true;
}

// -->
</script>

<script type="text/javascript">
<!--

function externalLinks() {
if (!document.getElementsByTagName) return;
var anchors = document.getElementsByTagName("a");
for (var i=0; i<anchors.length; i++) {
var anchor = anchors[i];
if (anchor.getAttribute("href") &&
anchor.getAttribute("rel") == "external")
anchor.target = "_blank";
}
}
window.onload = externalLinks;

// -->
</script>

</head>

ENDOFTEXT;

if ($this->KHXC->globals('importer.auto_submit')) {

     print '<body onload="document.forms[\'importer\'].submit()">' . $eol;

} else {

     print '<body>' . $eol;

} // End of if statement.

print <<<ENDOFTEXT

<div id="header"><img src="http://central.kryptronic.com/public/media/header_khxc.png" alt="KHXC" width="400" height="50" /></div>

<div id="content">

ENDOFTEXT;

// +--
// | Print the import type.
// +--

print '<p><strong>Data Importer</strong>: ' . $this->KHXC->xhtml_translate($this->KHXC->globals('importer.name'),'ENCODE');

// +--
// | Print the page header section.
// +--

$step     = $this->KHXC->xhtml_translate($this->KHXC->globals('importer.step'),'ENCODE');
$steptext = $this->KHXC->xhtml_translate($this->KHXC->globals('importer.steptext'),'ENCODE');
$numsteps = $this->KHXC->xhtml_translate($this->KHXC->globals('importer.numsteps'),'ENCODE');

if (($step) && ($steptext)) {

     print '<br /><strong>Step ' . $step . ' of ';
     print $numsteps . '</strong>: ' . $steptext;

} // End of if statement.

print '</p>' . $eol . $eol;

// +--
// | Print our content.
// +--

$content = $this->KHXC->globals('importer.buffered_output');

print $content;

// +--
// | Print the page footer.
// +--

print <<<ENDOFTEXT

</div>

<div id="footer">

<p class="inline">&copy; 1999-{$date_year} Kryptronic, Inc. All 
rights reserved worldwide. Kryptronic, the Kryptronic logo and all 
Kryptronic software names and logos are trademarks of Kryptronic, Inc.  
All Kryptronic software is copyrighted and the intellectual property of 
Kryptronic, Inc.  All Kryptronic software is developed and distributed 
under license by Kryptronic, Inc. Application Information: 
<a class="alt" href="http://www.kryptronic.com/" title="Kryptronic">http://www.kryptronic.com/</a></p>

</div>

</body>

</html>

ENDOFTEXT;

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: disp_message                                           |
// +------------------------------------------------------------------+

function disp_message ($message = '',$type = 'ERROR') {

// +--
// | This function prints a message.
// +--

$eol = $this->KHXC->globals('khxc.eol');

// +--
// | If message is blank, return true without printing anything.
// +--

if ($message == '') {return 1;}

// +--
// | Replace full directory paths in the message.
// +--

$pathpriv_quoted = preg_quote($this->KHXC->globals('khxc.path_private'),'/');
$pathpub_quoted  = preg_quote($this->KHXC->globals('khxc.path_public'),'/');

$message = preg_replace('/' . $pathpriv_quoted . '\//','/',$message);
$message = preg_replace('/' . $pathpub_quoted  . '\//','/',$message);

// +--
// | Encode the message.
// +--

$message = $this->KHXC->xhtml_translate($message,'ENCODE');

// +--
// | Print the message.
// +--

if ($type == 'ERROR') {

     print '<p class="msgerror">' . $message . '</p>' . $eol . $eol;

} else {

     print '<p class="msgconf">' . $message . '</p>' . $eol . $eol;

} // End of if statement.

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: formdata_array                                         |
// +------------------------------------------------------------------+

function formdata_array ($input = array()) {

// +--
// | This function returns an array of formdata values.  It accepts
// | input in an array with the following format:
// |
// | key:   The formdata field.
// | value: Boolean indicating required status.
// |
// | This function will return an error object if any required fields
// | are not complete.
// +--

$result = array();

if (empty($input)) {return $result;}

$reqnotcomp = 0;

foreach ($input as $key => $value) {

     $xvalue = $this->KHXC->globals('khxc_cgi.' . $key);

     if (!(isset($xvalue))) {$xvalue = '';}

     $result[$key] = $xvalue;

     if ((empty($result[$key])) && (!(empty($value)))) {$reqnotcomp++;}

} // End of foreach statement.

if ($reqnotcomp) {

     $message = "You did not complete all of the required fields before 
                 clicking the 'Continue' button.  Please try again.";

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Return the result array.
// +--

return $result;

} // End of function.

// +------------------------------------------------------------------+
// | Function: disp_form                                              |
// +------------------------------------------------------------------+

function disp_form ($input = array()) {

// +--
// | This function prints an XHTML form to be used by the importer.
// | 
// | Input is accepted in the form of an array with the following
// | parameters:
// |
// | 'header'   => XHTML header
// |
// | 'step'     => The step to post to.
// |
// | 'supform'  => Optional boolean indicator.  If true the opening 
// |               <form> tag is supressed.  Useful if the header
// |               contains form fields.
// |
// | 'autosub'  => Optional indicator.  If value is 1 this form 
// |               will be auto-submitted.
// |
// | 'fields'   => An array of fields with the following array keys:
// |
// |               'id'       => Form field name.
// |
// |               'name'     => Field display name.
// |
// |               'type'     => Form field type (SELECT, RADIO, HIDDEN
// |                           CHECKBOX, TEXT-REG, TEXT-LONG, PASSWORD)
// |
// |               'desc'     => Pre-formatted XHTML description.
// |
// |               'values'   => An array of values (key = select value,
// |                             value = select display name) for a 
// |                             SELECT, CHECKBOX or RADIO field.
// |
// |               'value'    => A value to use for HIDDEN fields.
// |
// |               'required' => Boolean required indicator.
// +--

$eol = $this->KHXC->globals('khxc.eol');

// +--
// | Set up function variables.
// +--

$header  = (isset($input['header'])  ? $input['header']  : '');
$fields  = (isset($input['fields'])  ? $input['fields']  : array());
$step    = (isset($input['step'])    ? $input['step']    : 'Default');
$supform = (isset($input['supform']) ? $input['supform'] : 0);
$autosub = (isset($input['autosub']) ? $input['autosub'] : 0);

// +--
// | Handle the auto-submit form object.
// +--

if ($autosub == 1) {

     $this->KHXC->globals('importer.auto_submit',1);

} // End of if statement.

// +--
// | Print the form header.
// +--

if ($header) {

     print $header . $eol . $eol;

} // End of if statement.

// +--
// | Print the <form> element and required info if not supressed.
// +--

if (empty($supform)) {

     $insname = $this->KHXC->globals('importer.script_name');

     print '<form action="' . $insname . '" method="post" id="importer">' . $eol . $eol;

     print '<p>All required fields are marked with a star (*). ';

     if ($autosub == 1) {

          print 'This form should auto-submit itself.  If this does not occur, ';
          print 'click the \'Continue\' button at the bottom of ';
          print 'this page to proceed.</p>' . $eol . $eol;


     } else {

          print 'Click the \'Continue\' button at the bottom of ';
          print 'this page to proceed.</p>' . $eol . $eol;

     } // End of if statement.

} // End of if statement.

// +--
// | Get a list of all of the fields.
// +--

$seen = array();

foreach ($fields as $num => $field) {

     $id = (isset($field['id']) ? $field['id'] : '');

     $seen[$id] = 1;

} // End of foreach statement.

// +--
// | Print the HIDDEN form fields.
// +--

foreach ($fields as $num => $field) {

     $id       = (isset($field['id'])       ? $field['id']       : '');
     $name     = (isset($field['name'])     ? $field['name']     : '');
     $type     = (isset($field['type'])     ? $field['type']     : '');
     $desc     = (isset($field['desc'])     ? $field['desc']     : '');
     $values   = (isset($field['values'])   ? $field['values']   : array());
     $value    = (isset($field['value'])    ? $field['value']    : '');
     $required = (isset($field['required']) ? $field['required'] : '');

     if ($type == 'HIDDEN') {

          $pid    = $this->KHXC->xhtml_translate($id,'ENCODE');
          $pvalue = $this->KHXC->xhtml_translate($value,'ENCODE');

          print '<p class="hidden"><input type="hidden" name="' . $pid . '" ';
          print 'id="' . $pid . '" value="' . $pvalue . '" /></p>' . $eol . $eol;

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print the ALL OTHER form fields.
// +--

foreach ($fields as $num => $field) {

     $id       = (isset($field['id'])       ? $field['id']       : '');
     $name     = (isset($field['name'])     ? $field['name']     : '');
     $type     = (isset($field['type'])     ? $field['type']     : '');
     $desc     = (isset($field['desc'])     ? $field['desc']     : '');
     $values   = (isset($field['values'])   ? $field['values']   : array());
     $value    = (isset($field['value'])    ? $field['value']    : '');
     $required = (isset($field['required']) ? $field['required'] : '');

     $req = ''; if ($required) {$req = '*';}

     $pvalue = $this->KHXC->globals('khxc_cgi.' . $id); if (empty($pvalue)) {$pvalue = '';}

     $pid    = $this->KHXC->xhtml_translate($id,'ENCODE');
     $pname  = $this->KHXC->xhtml_translate($name,'ENCODE');

     $xpid   = $pid;

     if (($type == 'CHECKBOX') || ($xpid == 'RADIO')) {$xpid .= '--1';}

     if ($type != 'HIDDEN') {

          print '<fieldset>' . $eol . $eol;

          print '<legend class="strong"><label for="' . $xpid . '">' . $pname . $req;
          print '</label></legend>' . $eol . $eol;

          print $desc . $eol . $eol;

          if (($type == 'TEXT-REG') || ($type == 'TEXT-LONG') || ($type == 'PASSWORD')) {

               $pvalue = $this->KHXC->xhtml_translate($pvalue,'ENCODE');

               $size  = '25';   if ($type == 'TEXT-LONG')  {$size = '50';}
               $xtype = 'text'; if ($type == 'PASSWORD')   {$xtype = 'password';}

               print '<input class="formfield" type="' . $xtype . '" name="';
               print $pid . '" id="' . $pid . '" value="';
               print $pvalue . '" size="' . $size . '" />' . $eol . $eol;

          } else {

               if (is_array($pvalue)) {$pvalue = array_flip($pvalue);} else {$pvalue = array($pvalue => 1);}

               if (!(empty($values))) {

                    $count   = 0;
                    $pvalues = array();

                    $made_checked = 0;

                    foreach ($values as $xkey => $xvalue) {

                         $count++;

                         $checked = 0; if (array_key_exists($xkey,$pvalue)) {$checked = 1; $made_checked = 1;}

                         $pvalues[] = array('value'   => $xkey,
                                            'display' => $this->KHXC->xhtml_translate($xvalue,'ENCODE'),
                                            'checked' => $checked,
                                            'xid'     => $id . '--' . $count);

                    } // End of foreach statement.

                    if ((!($made_checked)) && ($type == 'RADIO')) {$pvalues[0]['checked'] = 1;}

                    if ($type == 'SELECT') {

                          print '<select class="formfield" name="' . $pid . '" id="' . $pid . '">' . $eol;

                          foreach ($pvalues as $num => $xv) {

                               $checked = ''; if ($xv['checked']) {$checked = ' selected="selected"';}

                               print '<option value="' . $xv['value'] . '" ';
                               print $checked . '>' . $xv['display'] . '</option>' . $eol;

                          } // End of foreach statement.

                          print '</select>' . $eol . $eol;

                    } elseif ($type == 'CHECKBOX') {

                          foreach ($pvalues as $num => $xv) {

                               $checked = ''; if ($xv['checked']) {$checked = ' checked="checked"';}

                               print '<p><input type="checkbox" name="' . $pid . '[]" ';
                               print 'id="' . $xv['xid'] . '" value="' . $xv['value'] . '"';
                               print $checked . ' />' . ' ' . $xv['display'] . '</p>' . $eol;

                          } // End of foreach statement.

                    } elseif ($type == 'RADIO') {

                          foreach ($pvalues as $num => $xv) {

                               $checked = ''; if ($xv['checked']) {$checked = ' checked="checked"';}

                               print '<p><input type="radio" name="' . $pid . '" ';
                               print 'id="' . $xv['xid'] . '" value="' . $xv['value'] . '"';
                               print $checked . ' />' . ' ' . $xv['display'] . '</p>' . $eol;

                          } // End of foreach statement.

                    } // End of if statement.

               } // End of if statement.

          } // End of if statement.

          print '</fieldset>' . $eol . $eol;

     } // End of if statement.

} // End of foreach statement.

// +--
// | Print our license_agree, import_password and step fields
// | as well as other fields specific to this importer - if 
// | they weren't seen.
// +--

if (!(array_key_exists('license_agree',$seen))) {

     $value = $this->KHXC->globals('khxc_cgi.license_agree');

     if (is_array($value)) {$value = 1;}

     $value = $this->KHXC->xhtml_translate($value,'ENCODE');

     print '<p class="hidden"><input type="hidden" name="license_agree" ';
     print 'id="license_agree" value="' . $value . '" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('import_password',$seen))) {

     $value = $this->KHXC->xhtml_translate($this->KHXC->globals('khxc_cgi.import_password'),'ENCODE');

     print '<p class="hidden"><input type="hidden" name="import_password" ';
     print 'id="import_password" value="' . $value . '" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('step',$seen))) {

     print '<p class="hidden"><input type="hidden" name="step" ';
     print 'id="step" value="' . $step . '" /></p>' . $eol . $eol;

} // End of if statement.

if (($autosub == 1) && (!(array_key_exists('auto_submit',$seen)))) {

     print '<p class="hidden"><input type="hidden" name="auto_submit" ';
     print 'id="auto_submit" value="1" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('import_destapp',$seen))) {

     $import_destapp = $this->KHXC->globals('khxc_cgi.import_destapp');
     if (empty($import_destapp)) {$import_destapp = '';}

     print '<p class="hidden"><input type="hidden" name="import_destapp" ';
     print 'id="import_destapp" value="' . $import_destapp . '" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('import_dirdata',$seen))) {

     $import_dirdata = $this->KHXC->globals('khxc_cgi.import_dirdata');
     if (empty($import_dirdata)) {$import_dirdata = '';}

     print '<p class="hidden"><input type="hidden" name="import_dirdata" ';
     print 'id="import_dirdata" value="' . $import_dirdata . '" /></p>' . $eol . $eol;

} // End of if statement.

if (!(array_key_exists('import_dirmedia',$seen))) {

     $import_dirmedia = $this->KHXC->globals('khxc_cgi.import_dirmedia');
     if (empty($import_dirmedia)) {$import_dirmedia = '';}

     print '<p class="hidden"><input type="hidden" name="import_dirmedia" ';
     print 'id="import_dirmedia" value="' . $import_dirmedia . '" /></p>' . $eol . $eol;

} // End of if statement.

// +--
// | Print the form footer.
// +--

print <<<ENDOFTEXT

<p><input class="formbutton" type="submit" name="SUBMIT" id="SUBMIT" value="Continue" onclick="return DisableSubmit('importer');" /></p>

</form>

ENDOFTEXT;

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Multi-Task Form Display                                          |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: do_multitask                                           |
// +------------------------------------------------------------------+

function do_multitask ($multitask = array()) {

// +--
// | This function presents a multi-task form.
// +--

$eol = $this->KHXC->globals('khxc.eol');

// +--
// | Define our current task.
// +--

$current_task_text = $this->KHXC->xhtml_translate($multitask['currtask'],'ENCODE');

// +--
// | Set up the progress bar.
// +--

$progress_bar = '';

$progress_bar_countt  = $multitask['ntaskcount'];
$progress_bar_counti  = $multitask['ntaskcurr'];
$progress_bar_disp    = 50;

$bars_disp= '';
$bars_leftdisp = '';
$bar_count= 0;

$pct = $progress_bar_counti / $progress_bar_countt;
$pct = round($pct,2);

$pct_disp = $pct * 100;

$bars = $progress_bar_disp * $pct;
$bars = round($bars);

while ($bar_count < $bars) {$bar_count++; $bars_disp .= '|';}

$bars_left = $progress_bar_disp - $bars;

$bar_count = 0;

while ($bar_count < $bars_left) {$bar_count++; $bars_leftdisp .= '|';}

$pct_leftdisp = 100 - $pct_disp;

$progress_bar  = '<p class="meter">Progress: </p>';

if ($bars) {$progress_bar .= '<p class="metercomp">' . $bars_disp . '</p>';}

if ($bars_left) {$progress_bar .= '<p class="meterpend">' . $bars_leftdisp . '</p>';}

$progress_bar .= '<p class="meter"> [' . $pct_disp . '%]</p>' . $eol . $eol;

$header = <<<ENDOFTEXT

<p>You have selected to process a multi-task operation.  If this page does 
not automatically refresh itself within one second, click the 'Continue' 
button to proceed.</p>

ENDOFTEXT;

$insname = $this->KHXC->globals('importer.script_name');

$header .= '<form action="' . $insname . '" method="post" id="importer">' . $eol . $eol;

$header .= <<<ENDOFTEXT

<fieldset>

<legend class="strong"><label for="taskdo">Task Status</label></legend>

<p>The progress meter below displays your progress during this multi-task operation.</p>

<div id='meter'>{$progress_bar}</div>

<p class="hidden"><input type="hidden" name="taskstatus" id="taskstatus" value="1" /></p>

</fieldset>

<fieldset>

<legend class="strong"><label for="currenttask">Current Task</label></legend>

<p>{$current_task_text}</p>

<p class="hidden"><input type="hidden" name="currenttask" id="currenttask" value="1" /></p>

</fieldset>

ENDOFTEXT;

// +--
// | Formulate the form fields.
// +--

$fields[0]['id']       = 'offset';
$fields[0]['type']     = 'HIDDEN';
$fields[0]['required'] = 0;
$fields[0]['value']    = $multitask['offset'];

$fields[1]['id']       = 'import_do';
$fields[1]['type']     = 'HIDDEN';
$fields[1]['required'] = 0;
$fields[1]['value']    = 1;

if (!(empty($multitask['mtcomplete']))) {

     $fields[2]['id']       = 'mtcomplete';
     $fields[2]['type']     = 'HIDDEN';
     $fields[2]['required'] = 0;
     $fields[2]['value']    = 1;

} // End of if statement.

// +--
// | Print the form.
// +--

$this->disp_form(array('header'   => $header,
                       'fields'   => $fields,
                       'step'     => $multitask['currstep'],
                       'supform'  => 1,
                       'autosub'  => 1));

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// |                                                                  |
// | Importer Common Functions                                        |
// |                                                                  |
// |------------------------------------------------------------------|
// |------------------------------------------------------------------|
// +------------------------------------------------------------------+

// +------------------------------------------------------------------+
// | Function: import_load_settings                                   |
// +------------------------------------------------------------------+

function import_load_settings ($filename = 'settings.csv') {

// +--
// | This function loads settings from the source install.
// +--

// +--
// | Load settings from the CSV file.
// +--

$settings_file = $this->KHXC->globals('khxc_cgi.import_dirdata') . '/tables/' . $filename;

$settings = $this->KHXC_File->parsecsv(array('filename' => $settings_file));

// +--
// | Handle errors.
// +--

if ($this->KHXC->IsError($settings)) {

     $message  = "An error was encountered while attempting to retrieve  
                  settings from the source installation.  The error 
                  returned was: ";

     $message .= $settings->GetMessage();

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

if (empty($settings['data'])) {

     $message  = "An error was encountered while attempting to retrieve  
                  settings from the source installation.  No Settings were 
                  found.";

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Formulate our return array.
// +--

$colprefix = preg_replace('/\.csv$/','',$filename);

$settings_return = array();

foreach ($settings['data'] as $num => $row) {

     $settings_return[$row[$colprefix . '_id']] = $row[$colprefix . '_value'];

} // End of foreach statement.

// +--
// | Return the settings.
// +--

return $settings_return;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_load_tabledefs                                  |
// +------------------------------------------------------------------+

function import_load_tabledefs ($settings = array()) {

// +--
// | This function loads table definitions.  It creates an array
// | with table names as keys and the data source as values.
// +--

// +--
// | Return an error if we weren't passed settings.
// +--

if (empty($settings)) {

     $message  = "An error was encountered while attempting to retrieve  
                  table information from the source installation.  No 
                  settings information was supplied.";

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Load tables from the CSV file.
// +--

$tables_file = $this->KHXC->globals('khxc_cgi.import_dirdata') . '/tables/tables.csv';

$tables = $this->KHXC_File->parsecsv(array('filename' => $tables_file));

// +--
// | Handle errors.
// +--

if ($this->KHXC->IsError($tables)) {

     $message  = "An error was encountered while attempting to retrieve  
                  table information from the source installation.  The error 
                  returned was: ";

     $message .= $tables->GetMessage();

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

if (empty($tables['data'])) {

     $message  = "An error was encountered while attempting to retrieve  
                  table information from the source installation.  No information
                  was found.";

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Formulate our return array.
// +--

$alt_found     = 0;
$tables_return = array();

foreach ($tables['data'] as $num => $row) {

     $tables_return[$row['tables_id']] = $row['tables_data_source'];

     if ($row['tables_data_source'] != 'CSV') {$alt_found++;}

} // End of foreach statement.

// +--
// | Connect to an RDBMS as specified in the settings if we found
// | at least one table with an alternate connection.
// +--

if ($alt_found) {

     // +--
     // | Load data from the altrdbms CSV table and formulate a DSN.
     // +--

     $altrdbms = $this->import_load_csvdata('altrdbms');
     $alttype  = $settings['alt_rdbms_type'];

     $username = '';
     $password = '';
     $hostname = '';
     $dbname   = '';
     $dbtype   = $alttype;

     if ($dbtype == 'MYSQL')     {$dbtype = 'mysql';}
     elseif ($dbtype == 'MSSQL') {$dbtype = 'mssql';}
     else                        {$dbtype = 'pgsql';}

     foreach ($altrdbms as $num => $row) {

          if ($row['altrdbms_type'] == $alttype) {

               if (($row['altrdbms_id'] == $alttype . '_host') || ($row['altrdbms_id'] == $alttype . '_server')) {

                    $hostname = $row['altrdbms_value'];

               } elseif (($row['altrdbms_id'] == $alttype . '_database') || ($row['altrdbms_id'] == $alttype . '_dbname')) {

                    $dbname = $row['altrdbms_value'];

               } elseif (($row['altrdbms_id'] == $alttype . '_username') || ($row['altrdbms_id'] == $alttype . '_uid')) {

                    $username = $row['altrdbms_value'];

               } elseif (($row['altrdbms_id'] == $alttype . '_password') || ($row['altrdbms_id'] == $alttype . '_pwd')) {

                    $password = $row['altrdbms_value'];

               } // End of if statement.

          } // End of if statement.

     } // End of foreach statement.

     $password = $this->KHXC_Crypt->decrypt($password,$settings['admin_register_ordernum']);

     $dsn = array('dbtype'   => $dbtype,
                  'username' => $username,
                  'password' => $password,
                  'hostname' => $hostname,
                  'dbname'   => $dbname);

     // +--
     // | Attempt to load KHXC_DB using an alternate handle.
     // +--

     $this->KHXC_DBX =& $this->KHXC->load_object(array('app'       => 'khxc',
                                                       'class'     => 'KHXC_DB',
                                                       'name'      => 'KHXC_DB_2',
                                                       'construct' => $dsn));

     // +--
     // | Handle constructor errors.
     // +--

     if ($this->KHXC->IsError($this->KHXC_DBX)) {

          $message  = "An error was encountered while attempting to create a new
                       database object to connect to the RDBMS specified in the 
                       source installation.  The error returned was: ";

          $message .= $this->KHXC_DBX->GetMessage();

          $result = $this->KHXC->RaiseError($message);

          return $result;

     } // End of if statement.

     // +--
     // | Connect and handle errors.
     // +--

     $result = $this->KHXC_DBX->connect();

     if ($this->KHXC->IsError($result)) {

          $message  = "An error was encountered while attempting to connect to 
                       the RDBMS specified in the source installation.  The 
                       error returned was: ";

          $message .= $result->GetMessage();

          $result = $this->KHXC->RaiseError($message);

          return $result;

     } // End of if statement.

} // End of if statement.

// +--
// | Return the settings.
// +--

return $tables_return;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_count_rows                                      |
// +------------------------------------------------------------------+

function import_count_rows ($table = '',$tabledefs = array()) {

// +--
// | This function counts the rows in a table and returns the count.
// +--

// +--
// | Return an error if we weren't passed a table to load or 
// | table definition information.
// +--

if ((empty($table)) || (empty($tabledefs))) {

     $message  = "An error was encountered while attempting to retrieve  
                  data from a table.  No table and/or table definition 
                  information was supplied.";

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Get the data based on the data source.
// +--

if ($tabledefs[$table] == 'CSV') {

     $data = $this->import_load_csvdata($table);

     return count($data);

} else {

     $count = $this->KHXC_DBX->sql_count(array('table' => $table));

     if (($this->KHXC->IsError($count)) || (empty($count))) {$count = 0;}

     return $count;

} // End of if statement.

// +--
// | Return the data.
// +--

return $data;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_load_data                                       |
// +------------------------------------------------------------------+

function import_load_data ($table = '',$tabledefs = array(),$offset = 0,$count = 100) {

// +--
// | This function loads data from a table.  It returns a DB-like
// | array.
// +--

// +--
// | Return an error if we weren't passed a table to load or 
// | table definition information.
// +--

if ((empty($table)) || (empty($tabledefs))) {

     $message  = "An error was encountered while attempting to retrieve  
                  data from a table.  No table and/or table definition 
                  information was supplied.";

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Get the data based on the data source.
// +--

if ($tabledefs[$table] == 'CSV') {

     $data = $this->import_load_csvdata($table);

     if ($count != 'ALL') {

          $data = array_slice($data, $offset, $count);

     } // End of if statement.

} else {

     $data = $this->import_load_rdbmsdata($table,$offset,$count);

} // End of if statement.

// +--
// | Return the data.
// +--

return $data;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_load_csvdata                                    |
// +------------------------------------------------------------------+

function import_load_csvdata ($table = '') {

// +--
// | This function loads data from a CSV file.  It returns a DB-like
// | array.
// +--

global $csvdata;

// +--
// | Return an error if we weren't passed a table to load.
// +--

if (empty($table)) {

     $message  = "An error was encountered while attempting to retrieve  
                  data from a CSV-based table.  No table was supplied.";

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Return cached data.
// +--

if (!(empty($csvdata[$table]))) {return $csvdata[$table];}

// +--
// | Load the data.
// +--

$file = $this->KHXC->globals('khxc_cgi.import_dirdata') . '/tables/' . $table . '.csv';

$data = $this->KHXC_File->parsecsv(array('filename' => $file));

// +--
// | Handle errors.
// +--

if ($this->KHXC->IsError($data)) {

     $message  = "An error was encountered while attempting to retrieve  
                  data from the {$table} CSV-based table.  The error 
                  returned was: ";

     $message .= $data->GetMessage();

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

if (empty($data['data'])) {return array();}

$csvdata[$table] = $data['data'];

unset($data);

// +--
// | Return the data.
// +--

return $csvdata[$table];

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_load_rdbmsdata                                  |
// +------------------------------------------------------------------+

function import_load_rdbmsdata ($table = '',$offset = 0,$count = 100) {

// +--
// | This function loads data from a RDBMS table.  It returns a DB-like
// | array.
// +--

// +--
// | Return an error if we weren't passed a table to load.
// +--

if (empty($table)) {

     $message  = "An error was encountered while attempting to retrieve  
                  data from a RDBMS-based table.  No table was supplied.";

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Load the data.
// +--

$columns = $this->KHXC_DBX->table_column_string($table);

if ($this->KHXC->IsError($columns)) {

     $message  = "An error was encountered while attempting to retrieve  
                  column information from the {$table} RDBMS-based table. 
                  The error returned was: ";

     $message .= $columns->GetMessage();

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

$sql  = "SELECT {$columns} FROM {$table}";

if ($count == 'ALL') {

     $data = $this->KHXC_DBX->sql_do(array('sql'    => $sql,
                                           'table'  => $table,
                                           'order'  => array($table . '_id' => 'ASC')));

} else {

     $data = $this->KHXC_DBX->sql_do(array('sql'    => $sql,
                                           'table'  => $table,
                                           'order'  => array($table . '_id' => 'ASC'),
                                           'count'  => $count,
                                           'offset' => $offset));

} // End of if statement.

// +--
// | Handle errors.
// +--

if ($this->KHXC->IsError($data)) {

     $message  = "An error was encountered while attempting to retrieve  
                  data from the {$table} RDBMS-based table.  The error 
                  returned was: ";

     $message .= $data->GetMessage();

     $result = $this->KHXC->RaiseError($message);

     return $result;

} // End of if statement.

// +--
// | Return the data.
// +--

return $data;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_filter                                          |
// +------------------------------------------------------------------+

function import_filter ($filter = '', $value = '',$settings = array()) {

// +--
// | This function loads settings from the source install.
// +--

$filtered = '';

if ((empty($value)) || (empty($settings))) {return $filtered;}

// +--
// | FILTER: yn2bool
// +--

if ($filter == 'yn2bool') {

     if ($value == 'Y') {$filtered = '1';} else {$filtered = '0';}

// +--
// | FILTER: password
// +--

} elseif ($filter == 'password') {

     $filtered = $this->KHXC_Crypt->decrypt($value,$settings['admin_register_ordernum']);
     $filtered = md5($filtered);

// +--
// | FILTER: strtolower
// +--

} elseif ($filter == 'strtolower') {

     $filtered = strtolower($value);
// +--
// | FILTER: priceround
// +--

} elseif ($filter == 'priceround') {

     $price = round($value, 2);

     if (preg_match('/\./',$price)) {

          list($integer, $decimal) = split('\.', $price, 2);

     } else {

          $integer = $price;
          $decimal = '0';

     } // End of if statement.

     while (strlen($decimal) < 2) {$decimal .= '0';}

     $filtered = $integer . '.' . $decimal;
// +--
// | FILTER: Manage Vat
// +--

} elseif ($filter == 'manage_vat') {

     if ($value == 'N') {$filtered = 'no';} 
	 else if ($value == 'E') {$filtered = 'excleutax';}
	 else if ($value == 'I') {$filtered = 'incleutax';}

} elseif ($filter == 'vat_rebate') {

     if ($value == 'N') {$filtered = 'N';} 
	 else if ($value == 'Y') {$filtered = 'Y';}
	 else if ($value == 'E') {$filtered = 'V';}

} elseif ($filter == 'vat_shipping') {

     if ($value == 'N') {$filtered = 'N';} 
	 else if ($value == 'Y') {$filtered = 'Y';}

} elseif ($filter == 'taxcountry') {

     if ($value == 'N') {$filtered = 'Z';} 
	 else if ($value == 'Y') {$filtered = 'H';}

} elseif ($filter == 'priceround') {

     $filtered = $value;

} elseif ($filter == 'country') {
     if ($value == 'United Kingdom') {$filtered = 'UK - England & Wales';} 
	 else if ($value == 'United Kingdom Main Land') {$filtered = 'UK - England & Wales';}
	 else if ($value == 'Highlands & Islands Scotland') {$filtered = 'UK - Highlands & Islands Scotland';}
	 else if ($value == 'Isles Of Scilly') {$filtered = 'UK - Highlands & Islands Scotland';}
	 else if ($value == 'Isle of Man') {$filtered = 'UK- Isle of Man';}
	 else if ($value == 'Channel Islands') {$filtered = 'UK - Channel Islands';}
	 else if ($value == 'Northern Ireland') {$filtered = 'UK - Northern Ireland';}
	 else { $filtered = $value;}

} // End of if statement.

// +--
// | Return the filtered value.
// +--

return $filtered;

} // End of function.

// +------------------------------------------------------------------+
// | Function: import_changetags                                      |
// +------------------------------------------------------------------+

function import_changetags ($value = '') {

// +--
// | Returns a string stripped of all CGIVAR and CGIGET with 
// | links and image paths fixed.
// +--

if (empty($value)) {return $value;}

// +--
// | Images paths.
// +--

$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/site/','media/<?php print $this->globals(\'khxc.app\'); ?>/html',$value);
$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/category/','media/<?php print $this->globals(\'khxc.app\'); ?>/cat',$value);
$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/product\_category/','media/<?php print $this->globals(\'khxc.app\'); ?>/prodsm',$value);
$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/product\_detail/','media/<?php print $this->globals(\'khxc.app\'); ?>/prodlg',$value);
$value = preg_replace('/\(CGIVAR\)images_path\(\/CGIVAR\)\/product\_xlarge/','media/<?php print $this->globals(\'khxc.app\'); ?>/prodxl',$value);

// +--
// | URLs specifying reference strings.
// +--

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)prod\&ref\=(.*?)\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'prodshow\',array(\'ref\' => \'\\2\')); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)cat\&ref\=(.*?)\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'catshow\',array(\'ref\' => \'\\2\')); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)form\&ref\=(.*?)\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'dynform\',array(\'ref\' => \'\\2\')); ?>"',$value);

// +--
// | Special URLs.
// +--

$owner_name = $this->KHXC->globals('khxc_settings.khxc.site_name');

$value = preg_replace('/\(CGIVAR\)common_url_checkout\(\/CGIVAR\)"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'checkout\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url_custacct\(\/CGIVAR\)"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'login\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url_affacct\(\/CGIVAR\)"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'login\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)design_firm_url\(\/CGIVAR\)/','http://www.kryptronic.com',$value);
$value = preg_replace('/\(CGIVAR\)design_firm_name\(\/CGIVAR\)/','Kryptronic',$value);
$value = preg_replace('/\(CGIVAR\)site_owner_name\(\/CGIVAR\)/',$owner_name,$value);

// +--
// | URLs specifying system pages.
// +--

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)contact\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'contact\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)maillist\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'login\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)splash\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'display\',array(\'ref\' => \'splash\')); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)cart\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'viewcart\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)store\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'splash\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)search\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'prodsearch\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)specials\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'prodspec\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)bestsell\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'prodbest\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)new\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'prodnew\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)track\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'login\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)custacct\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'login\',array()); ?>"',$value);
$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg(.*?)affacct\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'login\',array()); ?>"',$value);

// +--
// | All other URLs.
// +--

$value = preg_replace('/\(CGIVAR\)common_url\(\/CGIVAR\)\&pg\=(.*?)\"/','<?php print $this->link_namespace($this->globals(\'khxc.app\'),\'display\',array(\'ref\' => \'\\1\')); ?>"',$value);

// +--
// | Strip font tags.
// +--

$value = preg_replace('/\<FONT(.*?)\>/i','',$value);
$value = preg_replace('/\<\/FONT\>/i','',$value);

// +--
// | Fix some tags we care about.
// +--

$value = preg_replace('/\<B\>/i','<strong>',$value);
$value = preg_replace('/\<\/B\>/i','</strong>',$value);
$value = preg_replace('/\<BR\>/i','<br />',$value);

// +--
// | Strip anything within FORM tags.
// +--

$value = preg_replace('/\<FORM(.*?)\>(.*?)\<\/FORM\>/i','',$value);

// +--
// | Remove any CGIVAR and CGIGET tags that were not stripped.
// +--

$value = preg_replace('/\(CGIVAR\)(.*?)\(\/CGIVAR\)/','',$value);
$value = preg_replace('/\(CGIGET TYPE="(.*?)" VALUE="(.*?)" PARAMS="(.*?)"\)/','',$value);
$value = preg_replace('/\(CGIGET TYPE="(.*?)" VALUE="(.*?)"\)/','',$value);

// +--
// | Return the value.
// +--

return $value;

} // End of if statement.

// +------------------------------------------------------------------+
// | Function: import_price_round                                     |
// +------------------------------------------------------------------+

function import_price_round ($price = '0.00') {

// +--
// | Return a rounded price.
// +--

$price = round($price, 2);

if (preg_match('/\./',$price)) {

     list($integer, $decimal) = split('\.', $price, 2);

} else {

     $integer = $price;
     $decimal = '0';

} // End of if statement.

while (strlen($decimal) < 2) {$decimal .= '0';}

return $integer . '.' . $decimal;

} // End of if statement.

// +------------------------------------------------------------------+
// | Function: import_return_skinphp                                  |
// +------------------------------------------------------------------+

function import_return_skinphp () {

// +--
// | Return the skin.php template.
// +--

return <<<ENDOFTEXT
     <?php /* PHP FUNCTION */
           /* REQUIRED: Skin startup */
           \$skinfunc =& \$this->include_skinfunc('KHXC_SkinFunc');
           extract(\$skinfunc->startup()); ?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<html>

<head>

<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" />

<meta name="keywords" content="<?php print \$metakeywords; ?>" />

<meta name="description" content="<?php print \$metadesc; ?>" />

<meta name="robots" content="index,follow" />

<base href="<?php print \$disp_baseurl; ?>" />

     <?php /* PHP FUNCTION */
           /* REQUIRED: Prints lightbox code */
           \$skinfunc->lightbox(); ?>

<link rel="stylesheet" type="text/css" media="all" href="skins/CCP5XIMPORT/css/all.css" />

<script type="text/javascript" src="skins/CCP5XIMPORT/scripts/scripts.js"></script>

<title><?php print \$metatitle; ?></title>

</head>

     <?php /* PHP FUNCTION */
           /* REQUIRED: Prints the body tag */
           \$skinfunc->bodytag(); ?>

<div id="skin_wrapper">

<khxc:content />

</div>

<div id="skin_footer">

     <?php /* PHP FUNCTION */
           /* Print the application owner's address and phone */
           /* numbers here.                                   */
           \$skinfunc->printaddphone(); ?>

<p>&copy; <?php print \$disp_year . ' ' . \$site_name; ?>. All rights reserved worldwide.</p>

<p>
<a href="http://www.kryptronic.com/" title="Kryptronic"><img src="media/khxc/powered_khxc.png" alt="KHXC Powered" width="79" height="24" /></a>
&nbsp;
<img src="media/khxc/valid-xhtml10.png" alt="Valid XHTML" width="79" height="24" />
&nbsp;
<img src="media/khxc/valid-css.png" alt="Valid CSS" width="79" height="24" /></p>

</div>

     <?php /* PHP FUNCTION */
           /* REQUIRED: Run the debug and closure function. */
           \$skinfunc->debug(); ?>

</body>

</html>

ENDOFTEXT;

} // End of if statement.

// +------------------------------------------------------------------+
// | Function: import_return_allcss                                   |
// +------------------------------------------------------------------+

function import_return_allcss () {

// +--
// | Return the all.css template.
// +--

return <<<ENDOFTEXT

body {
     color: #000000;
     background-color: #FFFFFF;
     font-family: Verdana, Tahoma, Arial, sans-serif;
     font-size: 11px;
     font-weight: normal;
     text-align: left;
     margin: 10px;
     }

a {
     color: #0000FF;
     background-color: inherit;
     font-weight: bold;
     text-decoration: none;
     cursor: pointer;
     }

p {
     color: inherit;
     background-color: inherit;
     margin: 5px 0px 7px 0px;
     }

sup {
     color: inherit;
     background-color: inherit;
     display: inline;
     padding: 0px;
     vertical-align: super;
     font-size: 8px;
     }

a:hover {
     color: inherit;
     background-color: inherit;
     text-decoration: underline;
     }

fieldset {
     color: inherit;
     background-color: inherit;
     border: none;
     padding: 5px 0px 5px 0px;
     }

fieldset p {
     color: inherit;
     background-color: inherit;
     display: block;
     font-size: 11px;
     margin: 5px 5px 5px 2px;
     }

form {
     color: inherit;
     background-color: inherit;
     margin: 0px 0px 5px 0px;
     }

img {
     color: inherit;
     background-color: inherit;
     border: none;
     }

li {
     color: inherit;
     background-color: inherit;
     padding-bottom: 5px;
     }

.center {
     color: inherit;
     background-color: inherit;
     text-align: center;
     }

.inlinecenter {
     color: inherit;
     background-color: inherit;
     text-align: center;
     }

p.inline {
     color: inherit;
     background-color: inherit;
     display: inline;
     padding: 0px;
     }

.strong {
     color: inherit;
     background-color: inherit;
     font-weight: bold;
     }

.big {
     font-weight: bold;
     font-size: 14px;
     }

.hidden {
     color: inherit;
     background-color: inherit;
     display: none;
     }

a.unfancy {
     color: inherit;
     background-color: inherit;
     text-decoration: underline;
     font-weight: normal;
     }

a.unfancy:hover {
     color: inherit;
     background-color: inherit;
     text-decoration: underline;
     }

#skin_wrapper {
     color: inherit;
     background-color: inherit;
     width: 90%;
     padding: 5px;
     margin: auto;
     }

#skin_content {
     color: inherit;
     background-color: inherit;
     margin: auto;
     }

#skin_footer {
     text-align: center;
     color: inherit;
     background-color: inherit;
     width: 99%;
     padding: 5px;
     margin-top: 10px;
     }

#skin_pgtitle {
     color: #333333;
     background-color: inherit;
     padding: 3px 5px 3px 5px;
     margin: 0px 0px 10px 0px;
     border-bottom: 1px solid #CCCCCC;
     font-weight: bold;
     font-size: 14px;
     }

.skin_fenavh {
     color: #333333;
     background-color: inherit;
     padding: 3px 5px 3px 5px;
     margin: 0px 0px 0px 0px;
     border-bottom: 1px solid #CCCCCC;
     font-weight: bold;
     }

.skin_fenav ul {
     color: inherit;
     background-color: inherit;
     padding: 0px;
     margin: 0px 0px 10px 0px;
     list-style: none;
     }

.skin_fenav ul li {
     color: inherit;
     background-color: inherit;
     padding: 0px;
     margin: 0px;
     border-bottom: 1px solid #CDCDCD;
     list-style: none;
     }

.skin_fenav ul li a {
     color: #333333;
     background-color: inherit;
     font-weight: normal;
     display: block;
     text-decoration: none;
     padding: 3px 5px 3px 5px;
     }

.skin_fenav ul li a:hover {
     color: #333333;
     background-color: #CCCCCC;
     text-decoration: none;
     }

.skin_button {
     color: #333333;
     background-color: #CCCCCC;
     padding: 0px;
     border: 1px solid #36586F;
     margin: 0px 0px 10px 3px;
     display: block;
     float: right;
     }

.skin_button a {
     color: #333333;
     background-color: #CCCCCC;
     font-weight: normal;
     display: block;
     padding: 2px 7px 2px 7px;
     }

.skin_button a:hover {
     color: #333333;
     background-color: #EFEFEF;
     text-decoration: none;
     }

.skin_fenavmini {
     color: inherit;
     background-color: inherit;
     padding: 5px;
     margin: 0px 0px 10px 0px;
     border-left: 1px solid #36586F;
     border-right: 1px solid #36586F;
     border-bottom: 1px solid #36586F;
     }

#khxc_debug {
     color: #333333;
     background-color: #FFFFFF;
     border: 1px solid #000000;
     padding: 10px;
     overflow: hidden;
     margin-top: 10px;
     }

#khxc_printable {
     color: inherit;
     background-color: #FFFFFF;
     border: 1px solid #000000;
     width: 800px;
     padding: 10px;
     margin: auto;
     }

.khxc_error {
     color: #FF0000;
     background-color: inherit;
     font-weight: bold;
     }

.khxc_confirm {
     color: #339933;
     background-color: inherit;
     font-weight: bold;
     }

.khxc_imgfloatrt {
     color: inherit;
     background-color: inherit;
     float: right;
     margin-bottom: 10px;
     margin-left: 10px;
     display: inline;
     }

.khxc_inline {
     color: inherit;
     background-color: inherit;
     display: inline;
     }

.khxc_preboxed {
     color: inherit;
     background-color: #F7F7F7;
     margin: 5px 0px 0px 0px;
     padding: 5px;
     border: 1px solid #000000;
     font-family: Fixed, monospace;
     overflow: hidden;
     }

.khxc_formfieldradcb {
     color: inherit;
     background-color: inherit;
     }

.khxc_formfield {
     color: inherit;
     background-color: #FFFFFF;
     border: 1px solid #000000;
     font-size: 11px;
     margin: 5px 5px 0px 2px;
     }

.khxc_formfield:hover {
     color: inherit;
     background-color: #DEDEDE;
     }

.khxc_formfieldp {
     color: inherit;
     background-color: inherit;
     display: block;
     padding: 0px;
     margin: 0px;
     }

.khxc_formfieldpnfs {
     color: inherit;
     background-color: inherit;
     display: block;
     padding: 0px 5px 0px 5px;
     margin: 0px 0px 5px 0px;
     }

.khxc_formfielda {
     color: #0000FF;
     background-color: inherit;
     display: block;
     padding: 0px 5px 0px 5px;
     margin: 0px 0px 2px 0px;
     font-weight: normal;
     }

.khxc_formbutton {
     color: #333333;
     background-color: #CCCCCC;
     border: 1px solid #000000;
     padding: 1px;
     margin: 0px 0px 5px 0px;
     font-size: 11px;
     width: 130px;
     }

.khxc_formbutton:hover {
     color: #333333;
     background-color: #EFEFEF;
     }

.khxc_quickbutton {
     color: #333333;
     background-color: #CCCCCC;
     border: 1px solid #000000;
     padding: 1px;
     margin: 0px;
     font-size: 11px;
     width: 130px;
     }

.khxc_quickbutton:hover {
     color: #333333;
     background-color: #EFEFEF;
     }

.khxc_quickform {
     color: inherit;
     background-color: inherit;
     margin: 5px 0px 0px 0px;
     }

.khxc_quickfield {
     color: inherit;
     background-color: #DEDEDE;
     border: 1px solid #000000;
     font-size: 11px;
     margin: 1px 0px 0px 0px;
     }

.khxc_quickfield:hover {
     color: inherit;
     background-color: #FFFFFF;
     }

.khxc_formfieldradcb_rnc {
     color: inherit;
     background-color: #FFA4A4;
     }

.khxc_formfield_rnc {
     color: inherit;
     background-color: #FFA4A4;
     border: 1px solid #000000;
     font-size: 11px;
     margin: 5px 5px 0px 2px;
     }

.khxc_formfield_rnc:hover {
     color: inherit;
     background-color: #DEDEDE;
     }

.khxc_formsecthead {
     color: #333333;
     background-color: inherit;
     padding: 2px 5px 2px 5px;
     margin: 0px;
     font-weight: bold;
     font-size: 14px;
     border-bottom: 1px solid #CCCCCC;
     }

table.khxc_formtblone {
     color: inherit;
     background-color: inherit;
     margin: 0px 0px 5px 0px;
     border-spacing: 3px;
     width: 100%;
     }

table.khxc_formtbltwo {
     color: inherit;
     background-color: inherit;
     margin: 0px 0px 5px 0px;
     border-spacing: 3px;
     width: 100%;
     }

td.khxc_formtbltwo {
     color: inherit;
     background-color: #F7F7F7;
     padding: 4px 2px 2px 2px;
     width: 50%;
     border-top: 1px solid #BCBCBC;
     border-left: 1px solid #BCBCBC;
     vertical-align: top;
     }

td.khxc_formtbltwospan {
     color: inherit;
     background-color: #F7F7F7;
     padding: 4px 2px 2px 2px;
     width: 100%;
     border-top: 1px solid #BCBCBC;
     border-left: 1px solid #BCBCBC;
     vertical-align: top;
     }

td.khxc_formtblone {
     color: inherit;
     background-color: #F7F7F7;
     padding: 4px 2px 2px 2px;
     width: 50%;
     border-top: 1px solid #BCBCBC;
     border-left: 1px solid #BCBCBC;
     vertical-align: top;
     }

table.khxc_sorttable {
     color: inherit;
     background-color: inherit;
     margin: 0px 0px 0px 0px;
     border-spacing: 3px;
     width: 100%;
     }

th.khxc_sorttable {
     color: inherit;
     background-color: inherit;
     padding: 4px 3px 4px 3px;
     border-top: 1px solid #CDCDCD;
     border-left: 1px solid #CDCDCD;
     vertical-align: top;
     }

td.khxc_sorttable {
     color: inherit;
     background-color: inherit;
     padding: 4px 3px 4px 3px;
     border-top: 1px solid #CDCDCD;
     border-left: 1px solid #CDCDCD;
     vertical-align: top;
     }

.khxc_regtablehead {
     color: #333333;
     background-color: inherit;
     padding: 2px 5px 2px 5px;
     margin: 0px;
     border-bottom: 1px solid #CCCCCC;
     font-weight: bold;
     font-size: 14px;
     clear: both;
     }

table.khxc_regtable {
     color: inherit;
     background-color: inherit;
     margin: 0px 0px 5px 0px;
     border-spacing: 3px;
     width: 100%;
     }

tr.khxc_regtable {
     color: inherit;
     background-color: inherit;
     padding: 5px;
     border: 1px solid #000000;
     }

th.khxc_regtable {
     color: inherit;
     background-color: inherit;
     padding: 4px 3px 4px 3px;
     border-top: 1px solid #CDCDCD;
     border-left: 1px solid #CDCDCD;
     vertical-align: top;
     }

td.khxc_regtable {
     color: inherit;
     background-color: #F7F7F7;
     padding: 4px 3px 4px 3px;
     border-top: 1px solid #CDCDCD;
     border-left: 1px solid #CDCDCD;
     vertical-align: top;
     }

.khxc_regtable p {
     color: inherit;
     background-color: inherit;
     padding: 0px;
     margin: 0px 0px 5px 0px;
     }

table.khxc_ghost {
     color: inherit;
     background-color: inherit;
     margin: 0px;
     padding: 0px;
     border-spacing: 3px;
     width: 100%;
     }

td.khxc_ghost {
     color: inherit;
     background-color: inherit;
     padding: 0px;
     margin: 0px;
     vertical-align: top;
     }

.khxc_ghost form {
     color: inherit;
     background-color: inherit;
     display: inline;
}

td.khxc_ghost img {
     color: inherit;
     background-color: inherit;
     margin-right: 10px;
     margin-bottom: 10px;
     }

td.khxc_ghost p {
     margin: 0px 0px 6px 0px;
}

p.khxc_uktablesp {
     color: inherit;
     background-color: inherit;
     margin: 0px;
     font-size: 1px;
     }

.khxc_storehead {
     color: #333333;
     background-color: inherit;
     padding: 2px 5px 2px 5px;
     margin: 10px 0px 2px 0px;
     border-bottom: 1px solid #CCCCCC;
     font-weight: bold;
     font-size: 14px;
     clear: both;
     }

.khxc_storelink {
     color: inherit;
     background-color: #F7F7F7;
     padding: 0px 5px 0px 5px;
     margin: 5px 0px 10px 0px;
     border: 1px solid #CCCCCC;
     }

.khxc_storelink a {
     color: #0000FF;
     background-color: inherit;
     font-weight: normal;
     }

.khxc_storelink p {
     color: inherit;
     background-color: inherit;
     margin: 4px 0px 4px 0px;
     }

table.khxc_cptbl_cat {
     color: inherit;
     background-color: inherit;
     margin: 0px 0px 10px 0px;
     border-spacing: 3px;
     width: 100%;
     }

tr.khxc_cptbl_cat {
     color: inherit;
     background-color: inherit;
     }

td.khxc_cptbl_cat {
     color: inherit;
     background-color: inherit;
     padding: 4px 4px 2px 4px;
     border: 1px solid #CCCCCC;
     vertical-align: top;
     }

td.khxc_cptbl_cat_blank {
     color: inherit;
     background-color: inherit;
     display: none;
     }

table.khxc_cptbl_prod {
     color: inherit;
     background-color: inherit;
     margin: 0px 0px 10px 0px;
     border-spacing: 3px;
     width: 100%;
     }

tr.khxc_cptbl_prod {
     color: inherit;
     background-color: inherit;
     }

td.khxc_cptbl_prod {
     color: inherit;
     background-color: inherit;
     padding: 4px 4px 2px 4px;
     border: 1px solid #CCCCCC;
     vertical-align: top;
     }

td.khxc_cptbl_prod_blank {
     color: inherit;
     background-color: inherit;
     display: none;
     }

table.khxc_cptbl_det {
     color: inherit;
     background-color: inherit;
     margin: 0px 0px 10px 0px;
     border-spacing: 3px;
     width: 100%;
     }

tr.khxc_cptbl_det {
     color: inherit;
     background-color: inherit;
     }

td.khxc_cptbl_det {
     color: inherit;
     background-color: inherit;
     padding: 4px 4px 2px 4px;
     border: 1px solid #CCCCCC;
     vertical-align: top;
     }

td.khxc_cptbl_det_blank {
     color: inherit;
     background-color: inherit;
     display: none;
     }

.khxc_pricediv {
     color: inherit;
     background-color: inherit;
     margin: 2px 0px 2px 0px;
     }

.khxc_price {
     color: inherit;
     background-color: inherit;
     display: inline;
     }

.khxc_pricex {
     color: #FF0000;
     background-color: inherit;
     display: inline;
     text-decoration: line-through;
     }

.khxc_cartbutton {
     color: #333333;
     background-color: #CCCCCC;
     border: 1px solid #000000;
     padding: 1px;
     font-size: 11px;
     font-weight: normal;
     text-align: center;
     display: block;
     margin: 0px 0px 5px 0px;
     width: 125px;
     }

.khxc_cartbutton:hover {
     color: #333333;
     background-color: #EFEFEF;
     text-decoration: none;
     cursor: default;
     }

table.khxc_ghost {
     color: inherit;
     background-color: inherit;
     margin: 0px;
     padding: 0px;
     border-spacing: 3px;
     width: 100%;
     }

td.khxc_ghost {
     color: inherit;
     background-color: inherit;
     padding: 0px;
     margin: 0px;
     vertical-align: top;
     }

.khxc_ghost form {
     color: inherit;
     background-color: inherit;
     display: inline;
}

td.khxc_ghost img {
     color: inherit;
     background-color: inherit;
     margin-right: 10px;
     margin-bottom: 10px;
     }

td.khxc_ghost p {
     margin: 0px 0px 6px 0px;
}

table.khxc_ordsumm {
     color: inherit;
     background-color: inherit;
     margin: 0px 0px 5px 0px;
     border-spacing: 3px;
     width: 100%;
     }

.khxc_ordsumm a {
     color: #0000FF;
     background-color: inherit;
     font-weight: bold;
     text-decoration: none;
     }

tr.khxc_ordsumm {
     color: inherit;
     background-color: inherit;
     padding: 5px;
     border: 1px solid #000000;
     }

th.khxc_ordsumm {
     color: inherit;
     background-color: inherit;
     padding: 4px 3px 4px 3px;
     border-top: 1px solid #CDCDCD;
     border-left: 1px solid #CDCDCD;
     vertical-align: top;
     }

td.khxc_ordsumm {
     color: inherit;
     background-color: #F7F7F7;
     padding: 4px 3px 4px 3px;
     border-top: 1px solid #CDCDCD;
     border-left: 1px solid #CDCDCD;
     vertical-align: top;
     }

.khxc_ordsumm p {
     color: inherit;
     background-color: inherit;
     padding: 0px;
     margin: 0px 0px 5px 0px;
     }

.khxc_ordsumm a {
     color: #3E6B8A;
     background-color: inherit;
     }

.khxc_ordsumm a:hover {
     color: inherit;
     background-color: inherit;
     text-decoration: underline;
     }

.khxc_ordsummhead {
     color: #333333;
     background-color: inherit;
     padding: 2px 5px 2px 5px;
     margin: 0px;
     border-bottom: 1px solid #CCCCCC;
     font-weight: bold;
     font-size: 14px;
     clear: both;
     }

.khxc_ordsummcenter {
     color: inherit;
     background-color: inherit;
     text-align: center;
     padding: 0px;
     margin: 0px 0px 10px 0px;
     border: 1px solid #000000;
     }

.khxc_ordsummbig {
     color: inherit;
     background-color: inherit;
     font-weight: bold;
     font-size: 16px;
     }

.khxc_ordsummlink {
     color: inherit;
     background-color: #F7F7F7;
     padding: 0px 5px 0px 5px;
     margin: 10px 0px 10px 0px;
     border: 1px solid #CCCCCC;
     }

.khxc_ordsummlink a {
     color: #0000FF;
     background-color: inherit;
     font-weight: normal;
     }

h1.khxc_secthead {
     color: inherit;
     background-color: inherit;
     font-weight: bold;
     font-size: 11px;
     text-decoration: underline;
     }

.khxc_clearboth {
     color: inherit;
     background-color: inherit;
     clear: both;
     }

.khxc_outstock {
     color: #FF0000;
     background-color: inherit;
     }

a.khxc_hrefbutton {
     color: #333333;
     background-color: #CCCCCC;
     border: 1px solid #000000;
     padding: 2px 5px 2px 5px;
     font-size: 11px;
     font-weight: normal;
     text-align: center;
     display: block;
     }

a.khxc_hrefbutton:hover {
     color: #333333;
     background-color: #EFEFEF;
     text-decoration: none;
     cursor: default;
     }

.khxc_outline {
     color: inherit;
     background-color: #F7F7F7;
     border: 1px solid #CCCCCC;
     padding: 5px;
     margin-top: 5px;
     }

.khxc_outlinetrans {
     color: inherit;
     background-color: inherit;
     border: 1px solid #CCCCCC;
     }

.khxc_outline p {
     color: inherit;
     background-color: inherit;
     margin: 0px 0px 3px 0px;
}

ENDOFTEXT;

} // End of if statement.

// +------------------------------------------------------------------+
// | End of Class                                               [KHXC]|
// +------------------------------------------------------------------+

} // End of class.

// +------------------------------------------------------------------+
// | End Of File                                                [KHXC]|
// +------------------------------------------------------------------+

?>